//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  plSetPrinter eXgvO
//  sɃ[U`p쐬郁\bh̃eXg
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit UserSizePaperUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, plSetPrinter, Buttons;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    plSetPrinter1: TplSetPrinter;
    Panel1: TPanel;
    Edit1: TEdit;
    Panel2: TPanel;
    Edit2: TEdit;
    Panel3: TPanel;
    Panel5: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    BitBtn1: TBitBtn;
    ComboBox1: TComboBox;
    PrinterSetupDialog1: TPrinterSetupDialog;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private 錾 }
    FUserPaperName: string;
    FResultPaperName : string;
    procedure DisplayPaperSize;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  Printers,
  Math,
  ShellAPI;

{$R *.DFM}

//=============================================================================
//  p̃TCYw
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
begin
  //v^̈ꗗ쐬
  ComboBox1.Style := csDropDownList;
  ComboBox1.Items.Assign(plSetPrinter1.PrinterList);
  plSetPrinter1.PrinterName := Printer.Printers[Printer.PrinterIndex];

  ComboBox1.ItemIndex := ComboBox1.Items.IndexOf(plSetPrinter1.PrinterName);
  if ComboBox1.ItemIndex = -1 then ComboBox1.ItemIndex := 0;

  //[U`p̃TCY̏l
  Edit1.Text := '1200';
  Edit2.Text := '1800';
  //p
  FUserPaperName := 'eXgp';
end;

//=============================================================================
//  v^I
//  Delphi6,7łOnCloseUpCxgɋLq悢D
//=============================================================================
procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  plSetPrinter1.PrinterName := ComboBox1.Text;
end;

//=============================================================================
//  [U`p쐬Čʂ\
//  TCY͈͊OƎs
//  WindowsNT,2000̏ꍇ,쐬̌ȂƎs
//  [U`TCYƎǗĂꍇ͓po^ς݂Ǝs
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LPaperHorz : Integer;
  LPaperVert : Integer;
  LResText   : string;
begin
  LPaperHorz := StrToInt(Edit1.Text);
  LPaperVert := StrToInt(Edit2.Text);

  if plSetPrinter1.SetUserPaper(FUserPaperName, LPaperHorz, LPaperVert) then begin
    FResultPaperName := plSetPrinter1.PaperName;
    LResText := 'wpTCY̗pŎgp\ɂȂ܂D' + sLineBreak
              + FResultPaperName;
    MessageBox(Handle, PChar(LResText), '', MB_ICONINFORMATION);
  end else begin
    FResultPaperName := '';
    LResText := 'ȉ̗p܂̓TCY̓o^Ɏs܂@' + sLineBreak
              + 'vgT[oɂ͓o^ꂽ\܂D' + sLineBreak
              + FUserPaperName;
    MessageBox(Handle, PChar(LResText), '', MB_ICONINFORMATION);
  end;

  DisplayPaperSize;
end;

//=============================================================================
//  [U`p̍폜
//  Windows95,98ł͏ɐ(ۂɂ͍폜Ȃ)
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LText : string;
begin
  if plSetPrinter1.DeleteUserPaper(FUserPaperName) then begin
    if plSetPrinter1.PaperList.IndexOf(FUserPaperName) < 0 then begin
      LText := 'vgT[oȉ̗p폜܂D' + sLineBreak
             + FUserPaperName;
    end else begin
      LText := 'ȉ̗p̍폜Ɏs܂D' + sLineBreak
             + FUserPaperName;
    end;
    MessageBox(Handle, PChar(LText), '', MB_ICONINFORMATION);
  end else begin
    if (FUserPaperName <> FResultPaperName) and (FResultPaperName <> '') then begin
      LText := 'ȉ̗pgp܂CpTCYݒ肵łD'
             + sLineBreak
             + FResultPaperName + sLineBreak
             + 'vgT[oɈȉ̗pcĂ邩m܂D' + sLineBreak
             + FUserPaperName;
    end else begin
      if plSetPrinter1.PaperList.IndexOf(FUserPaperName) < 0 then begin
        LText := 'ȉ̗p͊ɍ폜Ă邩C݂܂D' + sLineBreak
               + FUserPaperName;
      end else begin
        LText := 'ȉ̗p̍폜Ɏs܂D' + sLineBreak
               + 'vgT[oɓo^ꂽ܂܂̉\܂C' + sLineBreak
               + '̃v^hCo͍폜ł܂D' + sLineBreak
               + FUserPaperName;
      end;
    end;
    MessageBox(Handle, PChar(LText), '', MB_ICONINFORMATION);
  end;

  //폜ꍇ̓ftHg̗pTCY\
  plSetPrinter1.GetPrinterInfo;
  DisplayPaperSize;
end;

//=============================================================================
//  [v^̐ݒ]_CAO\ČʂmF
//  v^ɕύXꍇGetPrinterInfosȂƕύXȂ
//=============================================================================
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if PrinterSetupDialog1.Execute then begin
    plSetPrinter1.GetPrinterInfo;
    DisplayPaperSize;
  end;
end;

//=============================================================================
//  [v^̃vpeB]_CAO\ČʂmF
//  {R|̃\bhShowDialogłGetPrinterInfo͕sv
//=============================================================================
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  plSetPrinter1.ShowDialog;
  DisplayPaperSize;
end;

//-----------------------------------------------------------------------------
//  32rbgWindows64rbgWindows𒲂ׂ֐
//  64rbgłWindows̏ꍇTrueԂ
//-----------------------------------------------------------------------------
function Is64bitWindows: Boolean;
var
  Wow64Proc : function(hProcess: THandle; var Wow64: BOOL): BOOL stdcall;
  RetFlag   : LongBool;
begin
  @Wow64Proc := GetProcAddress(GetModuleHandle('Kernel32.dll'), 'IsWow64Process');
  if @Wow64Proc <> nil then begin
    Wow64Proc(GetCurrentProcess, RetFlag);

    if SizeOf(THandle) = 4 then begin
      Result := RetFlag;
    end else
    if SizeOf(THandle) = 8 then begin
      Result := True;
    end;
  end else begin
    //Windows XP64rbgł
    Result := CheckWin32Version(5, 2);
  end;
end;

//=============================================================================
//  [vgT[õvpeB]_CAO\
//  [U`p̓o^ƍ폜̊mFp
//
//  ShellExecute̎gpɂusesShellAPIKv
//=============================================================================
procedure TForm1.BitBtn3Click(Sender: TObject);
var
  LCmdExe   : string;
  LCmdParam : string;
begin
  //64rbgWindows̏ꍇ32rbgEXȄꍇ
  if (Is64bitWindows) and (SizeOf(Pointer) = 4) then begin
    LCmdExe := 'C:\Windows\Sysnative\rundll32';
  end else begin
    LCmdExe := 'rundll32';
  end;
  LCmdParam := 'printui.dll,PrintUIEntry /s';

  ShellExecute(0, nil, PChar(LCmdExe), PChar(LCmdParam), nil, SW_SHOWNORMAL);
end;

//-----------------------------------------------------------------------------
//  擾p̕ƒ\
//-----------------------------------------------------------------------------
procedure TForm1.DisplayPaperSize;
var
  LPaperWmm : Integer;
  LPaperHmm : Integer;
begin
  //0.1mmPʂɊZ
  LPaperWmm := Ceil(plSetPrinter1.PaperWidth * 254.0 / plSetPrinter1.XResolution);
  //0.1mmPʂɊZ
  LPaperHmm := Ceil(plSetPrinter1.PaperHeight * 254.0 / plSetPrinter1.YResolution);

  //vZʂ𕶎ɂĕ\
  Panel5.Caption := '  ' + IntToStr(LPaperWmm);
  Panel6.Caption := '  ' + InttoStr(LPaperHmm);
end;

end.
