{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$WARNINGS OFF}
//=============================================================================
//  v^ݒR|[lg
//  R|[lgo^yуvpeBGfB^֌W
//
//-----------------------------------------------------------------------------
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plSetPrinterReg;

interface

uses
  {$IFDEF VER130}
  plSetPrinter, Windows, SysUtils, Classes, Forms, Controls, ToolWin,
  Printers, WinSpool, DsgnIntf, StdCtrls;
  {$ELSE}
  plSetPrinter, Windows,SysUtils, Classes, Forms, Controls, ToolWin,
  Printers, WinSpool, DesignIntf, StdCtrls, DesignEditors;
  {$ENDIF}

type
  //---------------------------------------------------------------------------
  //  IuWFNgCXyN^ŃvpeB_CAO\邽
  //---------------------------------------------------------------------------
  TPrinterPropertyEditor = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  //---------------------------------------------------------------------------
  //  v^vpeBNX֌W
  //---------------------------------------------------------------------------
  TPrinterNameProperty = class(TStringProperty)
  public
     function GetAttributes: TPropertyAttributes; override;
     procedure GetValues(Proc: TGetStrProc); override;
     function GetValue: String;override;
     procedure SetValue(const Value: String); override;
  end;
  
  //---------------------------------------------------------------------------
  //  v^̃vpeB̃_CAO֌W
  //  \bhEdit̂
  //---------------------------------------------------------------------------
  
  TPrinterProperty = class(TComponentEditor)  
  public
    procedure Edit; override;
  end;

procedure Register;

implementation

var
  PrinterNameList : TStringList;

type
  TTempplSetPrinter = class(TplSetPrinter);

{TPrinterNameProperty}

//=============================================================================
//  v^vpeB
//  IuWFNgCXyN^ł̑
//  Xg̑IƂ邽,Ǐop.
//=============================================================================
function TPrinterNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;
//=============================================================================
//  v^vpeB
//  IuWFNgCXyN^pɃv^̃Xg쐬
//=============================================================================
procedure TPrinterNameProperty.GetValues(Proc: TGetStrProc);
var
  Flags     : Cardinal;
  dwNeeded  : Cardinal;
  dwReturn  : Cardinal;
  pPinfo4   : PPrinterInfo4;
  pWork     : PPrinterInfo4;
  S         : String;
  i         : Integer;
begin
  //Xg
  PrinterNameList.Clear;
  PrinterNameList.Sort;

  pPInfo4  := nil;
  dwNeeded := 0;
  dwReturn := 0;

  //񋓑Ώۃv^̎
  Flags := PRINTER_ENUM_LOCAL or PRINTER_ENUM_CONNECTIONS;

  //dwNeeded0ɂĕKvȃobt@TCY擾
  EnumPrinters(Flags,nil,4,pPInfo4,dwNeeded,dwNeeded,dwReturn);

  if dwNeeded > 0 then begin

    //\̂̔zɕKvȃoCgm
    GetMem(pPinfo4, dwNeeded);
    try
      if EnumPrinters(Flags, nil, 4, pPinfo4, dwNeeded, dwNeeded, dwReturn) then begin
        pWork := pPinfo4;
        for i := 0 to dwReturn - 1 do begin
          if (pWork.Attributes and PRINTER_ATTRIBUTE_HIDDEN) = 0 then begin
            S := String(pWork.pPrinterName);
            PrinterNameList.Add(S);
          end;
          //̍\̂̔zɈړ
          Inc(pWork);
        end;
      end;
    finally
      FreeMem(pPinfo4);
    end;

    PrinterNameList.Sort;
    for i := 0 to PrinterNameList.Count - 1 do begin
      Proc(PrinterNameList[i]);
    end;
  end;
end;

//=============================================================================
//  v^vpeB
//  IuWFNgCXyN^ɕ\鎞Ɍďo֐
//=============================================================================
function TPrinterNameProperty.GetValue: String;
var
  PrtName : String;
  pt      : TplSetPrinter;
begin
  pt := GetComponent(0) as TplSetPrinter;
  if GetStrValue='' then begin
    Printer.PrinterIndex := -1;
    PrtName        := Printer.Printers[Printer.PrinterIndex];
    Result         := PrtName;
    pt.PrinterName := PrtName;
  end else begin
    Result := GetStrValue;
  end;
end;

//=============================================================================
//  v^vpeB
//  IuWFNgCXyN^Ƀv^ZbgƌĂ΂.
//=============================================================================
procedure TPrinterNameProperty.SetValue(const Value: String);
begin
  SetStrValue(Value);
end;

{TPrinterProperty}

//=============================================================================
//  v^̃vpeC̃_CAO\
//
//  tH[̃R|[lg_uNbNƃv^̃vpeB̐ݒ
//  _CAO\.̃_CAO̓v^hCo񋟂Ă.܂
//  v^̐,hCõo[WɂĈقȂ.
//=============================================================================
procedure TPrinterProperty.Edit;
var
  pt : TplSetPrinter;
begin
  pt := (Component as TplSetPrinter);
  //v^̃vpeB̃_CAO\
  TTempplSetPrinter(pt).EditPrinterInfo;
  //ꂪȂƃvpeBXVۑȂ
  Designer.Modified;
end;

{ TPrinterPropertyEditor }

//=============================================================================
//  IuWFNgCXyN^ŃvpeB_CAO\
//=============================================================================
procedure TPrinterPropertyEditor.Edit;
begin
  //v^̃vpeB̃_CAO\
  TTempplSetPrinter(GetComponent(0)).EditPrinterInfo;
  //ꂪȂƃvpeBXVۑȂ
  Designer.Modified;
end;

//=============================================================================
//  IuWFNgCXyN^ŃvpeB_CAO\
//=============================================================================
function TPrinterPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly];
end;

//=============================================================================
//  R|[lg̓o^֌W̐ݒ
//
//  ł[plXRAY]^uɓo^悤ɂĂ.
//=============================================================================
procedure Register;
begin
  RegisterComponents     ('plXRAY', [TplSetPrinter]);
  RegisterPropertyEditor (TypeInfo(String),TplSetPrinter, 'PrinterName',
                          TPrinterNameProperty);
  RegisterPropertyEditor (TypeInfo(TplPrinterProperties), TplSetPrinter, 'Properties',
                          TPrinterPropertyEditor);
  RegisterComponentEditor(TplSetPrinter, TPrinterProperty);
end;

//=============================================================================
//  vpeBGfB^̏ƏI
//  v^̃XgpTStringList̍쐬Ɣj
//=============================================================================
initialization
  PrinterNameList := TStringList.Create;
finalization
  PrinterNameList.Free;

//=============================================================================
//  R[hI
//=============================================================================
end.

