//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  v^̏\
//
//  ْplSetPrintergpv^vpeC̕\vO
//  v^̐ݒlȂǂ̊mFɎgp邽߂ɍ쐬
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2000.09.24 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(SP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plShowPrinterPropertiesUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, plSetPrinter, Grids;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    PrintDialog1: TPrintDialog;
    plSetPrinter1: TplSetPrinter;
    procedure StringGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
    procedure RightJustify(AGrid: TStringGrid; ARect: TRect; AText: string);
    procedure LeftJustify(AGrid: TStringGrid; ARect: TRect; AText: string);
    procedure SetCellsValues(Sender:TObject);
    function DisplayFormatX(Value:Integer):String;
    function DisplayFormatY(Value:Integer):String;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  Printers;

{$R *.DFM}

//-----------------------------------------------------------------------------
//  Obhɕ\^Cgp̕萔
//-----------------------------------------------------------------------------
const
  DisplayData : array[0..27] of string =
    (' v^ԍ',    ' PrinterNumber',
     ' rԍ',        ' BinNumber',
     ' pTCYԍ',  ' PaperNumber',
     ' 𑜓x',    ' XResolution',
     ' c𑜓x',    ' YResolution',
     ' p',          ' PaperWidth',
     ' p',        ' PaperHeight',
     ' \',      ' PageWidth',
     ' \',    ' PageHeight',
     ' \[',    ' LeftOffset',
     ' \[',    ' TopOffset',
     ' \E[',    ' RightOffset',
     ' \[',    ' BottomOffset',
     ' J[rbg',  ' ColorBit');

   //\ɕω邽߂̃Z̐F
   FOriginColor1: TColor=$00C8FFC8;
   FOriginColor2: TColor=$00E6E6E6;
   FOriginColor3: TColor=$00FFFFD0;


//=============================================================================
//  tH[\Jn̏
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  LRowNo      : Integer;
  LColNo      : Integer;
  LTextItemNo : Integer;
begin
  //ҏWsƂ
  ComboBox1.Style:=csDropDownList;

  //CXg[Ăv^̃Xg擾
  for LRowNo:=0 to Printer.Printers.Count - 1 do begin
    ComboBox1.Items.Add(Printer.Printers[LRowNo]);
  end;

  //N,ʏgpv^\
  Printer.PrinterIndex := -1;
  ComboBox1.ItemIndex := Printer.PrinterIndex;
  //TplSetPrinterR|[lgɖOm点ď
  plSetPrinter1.PrinterName := ComboBox1.Text;
  ComboBox2.ItemIndex:=0;

  //v^̕\pObh̗񕝂߂
  StringGrid1.ColWidths[0] := 130;
  StringGrid1.ColWidths[1] := StringGrid1.Width - StringGrid1.ColWidths[0];

  //p@̕\pObh̗񕝂߂
  StringGrid2.ColWidths[0] := 130;
  StringGrid2.ColWidths[1] := 150;
  StringGrid2.ColWidths[2] := StringGrid2.Width
                            - (StringGrid2.ColWidths[0] + StringGrid2.ColWidths[1]);

  //Obhɕ\
  StringGrid1.Cells[0,0] := ' v^';
  StringGrid1.Cells[0,1] := ' hCoo[W';
  StringGrid1.Cells[0,2] := ' r';
  StringGrid1.Cells[0,3] := ' pTCY';
  StringGrid1.Cells[0,4] := ' p';

  LTextItemNo := 0;
  for LRowNo := 0 to StringGrid2.RowCount - 1 do begin
    for LColNo := 0 to StringGrid2.ColCount - 2 do begin
      StringGrid2.Cells[LColNo, LRowNo] := DisplayData[LTextItemNo];
      LTextItemNo := LTextItemNo + 1;
    end;
  end;

  //Obh̃ZɊevpeBl\
  SetCellsValues(Self);
  BitBtn1.SetFocus;
end;

//=============================================================================
//  vOI
//=============================================================================
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

//=============================================================================
//  ɉʂn[hRs[@
//=============================================================================
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  //ݒ̃_CAO\
  Printer.PrinterIndex := -1;
  if PrintDialog1.Execute then begin
    Self.PrintScale := poProportional;
    Self.Print;
  end;
end;

//=============================================================================
//  v^̃vpeB_CAO\
//=============================================================================
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  //_CAO\
  plSetPrinter1.ShowDialog;
  //_CAO,ύXmȂ̂
  //ObhZɒlvZĕ\
  SetCellsValues(Self);
  BitBtn1.SetFocus;
end;

//=============================================================================
//  ComboBox1OnChangeCxg
//  R{{bNXŃv^IPrinterNameɒl
//=============================================================================
procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  //plSetPrinterɃv^m点
  plSetPrinter1.PrinterName := ComboBox1.Text;

  //ObhZɒl\
  SetCellsValues(Sender);
  BitBtn1.SetFocus;
end;

//=============================================================================
//  ComboBox2OnChangeCxg
//  R{{bNXŕ\PʂύXvZĒl\
//=============================================================================
procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  {ObhZɒl\}
  SetCellsValues(Self);
  BitBtn1.SetFocus;
end;

//-----------------------------------------------------------------------------
//  vpeBlZɕ\
//
//  𑜓xȂǂ͈ȉ̃\bhgpČ`𐮂ĕ\
//  DisplayFormatX ̃vpeClp
//  DisplayFormatY c̃vpeClp
//
//  Obh1 vpeB̖
//  Obh2 plSetPrinter̃vpeB̖
//  Obh3 \PʂɉvpeB̒l
//-----------------------------------------------------------------------------
procedure TForm1.SetCellsValues(Sender: TObject);
begin
  StringGrid1.Cells[1,0] := ' ' + plSetPrinter1.PrinterName;
  StringGrid1.Cells[1,1] := ' ' + IntToStr(plSetPrinter1.DriverVersion);
  StringGrid1.Cells[1,2] := ' ' + plSetPrinter1.BinName;
  StringGrid1.Cells[1,3] := ' ' + plSetPrinter1.PaperName;

  if plSetPrinter1.Orientation = poPortrait then begin
    StringGrid1.Cells[1,4] := ' Portrait(c)';
  end else begin
    StringGrid1.Cells[1,4] := ' Landscape()'
  end;

  StringGrid2.Cells[2,0] := IntToStr(plSetPrinter1.PrinterNumber);
  StringGrid2.Cells[2,1] := IntToStr(plSetPrinter1.BinNumber);
  StringGrid2.Cells[2,2] := IntToStr(plSetPrinter1.PaperNumber);
  StringGrid2.Cells[2,3] := IntToStr(plSetPrinter1.XResolution) + ' dpi';

  StringGrid2.Cells[2, 4] := IntToStr      (plSetPrinter1.YResolution) + ' dpi';
  StringGrid2.Cells[2,13] := IntToStr      (plSetPrinter1.ColorBit);
  StringGrid2.Cells[2, 5] := DisplayFormatX(plSetPrinter1.PaperWidth);
  StringGrid2.Cells[2, 6] := DisplayFormatY(plSetPrinter1.PaperHeight);
  StringGrid2.Cells[2, 7] := DisplayFormatX(plSetPrinter1.PageWidth);
  StringGrid2.Cells[2, 8] := DisplayFormatY(plSetPrinter1.PageHeight);
  StringGrid2.Cells[2, 9] := DisplayFormatX(plSetPrinter1.LeftOffset);
  StringGrid2.Cells[2,10] := DisplayFormatY(plSetPrinter1.TopOffset);
  StringGrid2.Cells[2,11] := DisplayFormatX(plSetPrinter1.RightOffset);
  StringGrid2.Cells[2,12] := DisplayFormatY(plSetPrinter1.BottomOffset);
end;

//-----------------------------------------------------------------------------
//  l`𐮂ɂ֐
//  ̃vpeClp
//-----------------------------------------------------------------------------
function TForm1.DisplayFormatX(Value: Integer): string;
var
  LValue : Real;
begin
  if ComboBox2.Text = 'dots(pixels)' then begin
    Result := IntToStr(Value);
  end else
  if ComboBox2.Text = 'mm' then begin
    LValue := Value * 25.4 / plSetPrinter1.XResolution;
    Result := Format('%10.2f', [LValue]);
  end else
  if ComboBox2.Text = '0.1 mm' then begin
    LValue := Value * 25.4 / plSetPrinter1.XResolution * 10.0;
    Result := Format('%10.1f', [LValue]);
  end else
  if ComboBox2.Text = 'inch' then begin
    LValue := Value / plSetPrinter1.XResolution;
    Result := Format('%10.2f', [LValue]);
  end else
  if ComboBox2.Text = '0.1 inch' then begin
    LValue := Value / plSetPrinter1.XResolution * 10.0;
    Result := Format('%10.1f', [LValue]);
  end;
end;

//-----------------------------------------------------------------------------
//  l`𐮂ɂ֐
//  c̃vpeClp
//-----------------------------------------------------------------------------
function TForm1.DisplayFormatY(Value: Integer): string;
var
  LValue : Real;
begin
  if ComboBox2.Text = 'dots(pixels)' then begin
    Result := IntToStr(Value);
  end else
  if ComboBox2.Text = 'mm' then begin
    LValue := Value * 25.4 / plSetPrinter1.YResolution;
    Result := Format('%10.2f', [LValue]);
  end else
  if ComboBox2.Text = '0.1 mm' then begin
    LValue := Value * 25.4 / plSetPrinter1.YResolution * 10.0;
    Result := Format('%10.1f', [LValue]);
  end else
  if ComboBox2.Text = 'inch' then begin
    LValue := Value / plSetPrinter1.YResolution;
    Result := Format('%10.2f', [LValue]);
  end else
  if ComboBox2.Text = '0.1 inch' then begin
    LValue := Value / plSetPrinter1.YResolution * 10.0;
    Result := Format('%10.1f', [LValue]);
  end;
end;

//=============================================================================
//  StringGrid1,2OnDrawCellCxg
//=============================================================================
procedure TForm1.StringGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  LGrid : TStringGrid;
begin
  LGrid := StringGrid1;
  //2̃Obh,̃\bhŕ`悷̂LGridƂO
  if Sender = StringGrid1 then LGrid := StringGrid1;
  if Sender = StringGrid2 then LGrid := StringGrid2;

  //ŒłȂ(f[^̕\Z)ꍇ
  if not (gdFixed in State) then begin

    //5sڂ12sڂ܂ł̓Z̔wiF݂ɕς
    if ARow in [5, 7, 9, 11] then begin
      LGrid.Canvas.Brush.Color := FOriginColor1;
    end else if ARow in [6, 8, 10, 12] then begin
      LGrid.Canvas.Brush.Color := FOriginColor3;
    end else begin
      LGrid.Canvas.Brush.Color := clWhite;
    end;

    LGrid.Canvas.Font.Color := clBlack;
    //2ڂ͉̕E񂹕\
    if ACol = 2 then begin
      RightJustify(LGrid,Rect, LGrid.Cells[ACol, ARow]);
    //ȊO̗͍̕񂹕\
    end else begin
      LeftJustify(LGrid, Rect, LGrid.Cells[ACol, ARow]);
    end;

  //Œ̏ꍇ
  end else begin
    //Z̔wi
    LGrid.Canvas.Brush.Color := FOriginColor2;
    //̐F
    LGrid.Canvas.Font.Color := clBlack;
    //񂹂ŕ\
    LeftJustify(LGrid, Rect, LGrid.Cells[ACol, ARow]);
  end;
end;

//-----------------------------------------------------------------------------
//  Z̍񂹕\[`
//-----------------------------------------------------------------------------
procedure TForm1.LeftJustify(AGrid: TStringGrid; ARect: TRect; AText: string);
begin
  //lp`݂Brush̎wœhׂ
  AGrid.Canvas.FillRect(ARect);
  //ォق̏ɕ`.{͐^vZׂ?
  AGrid.Canvas.TextRect(ARect, ARect.Left, ARect.Top + 2, AText);
end;

//-----------------------------------------------------------------------------
//  Z̉E񂹕\[`
//-----------------------------------------------------------------------------
procedure TForm1.RightJustify(AGrid: TStringGrid; ARect: TRect; AText: string);
var
  LLeft : Integer;
begin
  //lp`݂Brush̎wœhׂ
  AGrid.Canvas.FillRect(ARect);
  //`JnXW͉E[當̒̂班
  LLeft := ARect.Right - (AGrid.Canvas.TextWidth(AText) + 8);
  //ォق̏ɕ`.{͐^vZׂ?
  AGrid.Canvas.TextRect(ARect, LLeft, ARect.Top + 2, AText);
end;

end.
