//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  plSetPrinter ̃eXg
//  0.1mmPʎwŐ}`╶.
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit ScallingDrawUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, plSetPrinter, Buttons;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Label1: TLabel;
    plSetPrinter1: TplSetPrinter;
    PrintDialog1: TPrintDialog;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
    FPaperWidth : Integer;   //hbgŕ\p
    FPaperHeight: Integer;   //hbgŕ\p
    FPaperWmm   : Integer;   //0.1mmPʂŕ\p
    FPaperHmm   : Integer;   //0.1mmPʂŕ\p
    FPaperLO    : Integer;   //ItZbgl
    FPaperTO    : Integer;   //ItZbgl
    procedure GetPaperScale;
    procedure Scalling(ACanvas: TCanvas);
    procedure DrawRoutine;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  Printers;

{$R *.DFM}

//=============================================================================
//  tH[\Jn̏
//  mFpɃv^xɕ\
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  LText: string;
begin
  LText := plSetPrinter1.PrinterName;
  //݌ṽv^\
  Label1.Caption := LText;
end;

//=============================================================================
//  v^ɏo
//=============================================================================
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if PrintDialog1.Execute then begin
    //_CAOŐݒ肵e擾
    plSetPrinter1.GetPrinterInfo;
    //pTCY0.1mmPʂɊZ
    GetPaperScale;
     //Printer.Canvasɏo
    DrawRoutine;
  end;
end;

//-----------------------------------------------------------------------------
//  IpTCY(sNZP)0.1mmPʂ̐@ɊZ
//  (A4cȂPaperW=2100,PaperH=2970ƂȂ)
//-----------------------------------------------------------------------------
procedure TForm1.GetPaperScale;
begin
  //plSetPrinter̃vpeB牡ƒ̃hbg擾
  FPaperWidth  := plSetPrinter1.PaperWidth;
  FPaperHeight := plSetPrinter1.PaperHeight;

  //v^̉𑜓x̒l0.1mmPʂ̗p̐@vZ
  FPaperWmm := Trunc(FPaperWidth  * 254 / plSetPrinter1.XResolution);
  FPaperHmm := Trunc(FPaperHeight * 254 /plSetPrinter1.YResolution);

  //ItZbgl擾
  FPaperLO := plSetPrinter1.LeftOffset;
  FPaperTO := plSetPrinter1.TopOffset;
end;

//-----------------------------------------------------------------------------
//  `惋[`
//
//  `悷͕̂100.0mm,c120.0mm̎lp`.̑0.5mm.
//  `101mmPʂłł.
//-----------------------------------------------------------------------------
procedure TForm1.DrawRoutine;
var
  LText : string;
begin
  //镶
  LText := 'eXg';
  try
    //ߊJn
    Printer.BeginDoc;
    //XP[O
    Scalling(Printer.Canvas);
    //̑0.5mm
    Printer.Canvas.Pen.Width := 5;
    //lp`̕`JnW͍50.0mm,ォ80.0mm
    //E150.0mm,200.0mm̎lp`,܂蕝100.0mm,c120.0mm
    Printer.Canvas.Rectangle(500, 800, 1500, 2000);

    //fBO܂߂̍10.0mm
    Printer.Canvas.Font.Height := 100;
    //wi͓
    Printer.Canvas.Brush.Style := bsClear;
    //lp`̍ɕ`
    Printer.Canvas.TextOut(500, 800, LText);

    //镶̍mF̂߂̐
    Printer.Canvas.Pen.Width := 1;
    Printer.Canvas.MoveTo( 500, 900);
    Printer.Canvas.LineTo(1500, 900);
  finally
    //ftHg̃[hɖ߂
    SetMapMode(Printer.Canvas.Handle, MM_TEXT);
    //ߏI
    Printer.EndDoc;
  end;
end;

//-----------------------------------------------------------------------------
//  XP[O
//
//  ̃XP[Oȍ~,101mmPʂł̕`悪\ƂȂ.
//-----------------------------------------------------------------------------
procedure TForm1.Scalling(ACanvas: TCanvas);
begin
  //XP[Õ[h
  SetMapMode       (ACanvas.Handle,MM_ANISOTROPIC);
  SetWindowExtEx   (ACanvas.Handle,FPaperWmm,  FPaperHmm,    nil);
  SetViewPortExtEx (ACanvas.Handle,FPaperWidth,FPaperHeight, nil);
  //`挴_ړ
  SetViewPortOrgEx(ACanvas.Handle, -FPaperLO, -FPaperTO, nil);
end;

end.
