{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$WARNINGS OFF}
//=============================================================================
//  v^ݒR|[lg
//  Ver 9.03
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  dlCCmFɂĂ͓YtReadme.txtQ
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plSetPrinter;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms, Printers, Controls, ToolWin,
  WinSpool, StdCtrls, Dialogs;

type
  TplPrtDialogCloseEvent = procedure(Sender: TObject; ID: Integer) of object;

  TplPrinterProperties = class(TPersistent)
    //
  end;

  TplSetPrinter = class(TComponent)
  private
    { Private 錾}
    ADevice,ADriver,APort : array [0..511] of Char;
    ADevMode              : PDeviceMode;

    FProperties      : TplPrinterProperties;   //_~[
    FCustomPaperName : String;                 //[U`p
    hPrtHandle       : THandle;                //v^foCXhCõnh
    DevSize          : Integer;                //DevMode\̂̃TCY.ASettingsɕKv
    ASettings        : PByteArray;             //v^̐ݒlADevModẽRs[
                                               //TMemoryStream̕
    FPrintersCount   : Integer;                //CXg[Ăv^
    FPrinterName     : String;                 //|[g܂܂Ȃv^̖
    FdsPrinterName   : String;                 //|[g܂܂Ȃv^̖
    FPrinterNumber   : Integer;                //v^ԍ
    FOrientation     : TPrinterOrientation;    //
    FPaperName       : String;                 //TCY
    FPaperNumber     : Integer;                //pTCYԍ
    FBinNumber       : Integer;                //rԍ
    FDriverVersion   : Integer;                //hCoo[Wԍ

    FPrinterList     : TStringList;            //v^̃Xg(\[gς)
    FPaperList       : TStringList;            //p̃Xg
    FBinList         : TStringList;            //r̂̃Xg

    FOnDialogClose  : TplPrtDialogCloseEvent;  //_CAO̃Cxg
    FOnPrinterChange: TNotifyEvent;            //v^ύX̃Cxg

    FOnSetupDialogShow  : TNotifyEvent;
    FOnSetupDialogClose : TNotifyEvent;

    //DevSize̕ۊǂƓǏo
    procedure WriteADevSize(Writer: TWriter);
    procedure ReadADevSize (Reader: TReader);

    //DevMode̕ۊǂƓǏo
    procedure WriteADev(Writer: TStream);
    procedure ReadADev (Reader: TStream);

    //݌v̒l̕ۊǂƓǏo
    procedure WriteDesignValues(Writer: TWriter);
    procedure ReadDesignValues(Reader: TReader);

    function CheckPaperName(UserPaperName: String; var pNo: Integer): Boolean;
    function SetUserPaperNT(UserPaperName: String; CustomW, CustomH: Integer): Boolean;
    function CheckSetUserPaper(CustomW,CustomH: Integer): Boolean;
    function GetBinList: TStringList;
    function GetPaperList: TStringList;
    function GetPrinterList: TStringList;
    function GetFBinName: String;
    function GetFBinNumber: Integer;
    function GetFColorBit: Integer;
    function GetFDriverVersion: Integer;
    function GetFOrientation: TPrinterOrientation;
    function GetFPaperName: String;
    function GetFPaperNumber: Integer;
    function GetFPrintersCount: Integer;
    function GetDeviceCapsValues(const index: Integer): Integer;
    procedure SetFBinNumber(const Value: Integer);
    procedure SetFPrinterNumber(const Value: Integer);
    procedure SetFOrientation(const Value: TPrinterOrientation);
    procedure SetFPaperName(const Value: String);
    procedure SetFPaperNumber(const Value: Integer);
    procedure SetFBinName(const Value: String);
    procedure SetCopies(const Value: Integer);
    function GetCollate: Integer;
    function GetCopies: Integer;
    procedure SetCollate(const Value: Integer);
    procedure SetColor(const Value: Integer);
    function GetColor: Integer;
    function GetDuplex: Integer;
    procedure SetDuplex(const Value: Integer);
    function GetPrinterIndexFromString(Str: String): Integer;
    function GetPrinterNameFromString(Str: String): String;
    function GetPrinterName: String;
    procedure ModifyDevMode(Value: PDeviceMode);
    procedure ModifyOrGetDevModeBegin;
    procedure GetPropertiesAndSettings;
  protected
    { Protected 錾 }
    procedure Loaded; override;
    procedure DefineProperties(Filer: TFiler);override;
    procedure SetPrinterName(Value: String);
    function SetOldPropertiesAndSettings : Boolean;
    procedure ChangeCurrentPrinter;
    function EditPrinterInfo: Boolean;
    procedure ForSetupDialogOnShow(Sender: TObject);
    procedure ForSetupDialogOnClose(Sender: TObject);
    property CustomPaperName : String read FCustomPaperName;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent);override;
    destructor Destroy; override;
    
    //vpeBl̒ɂDWORD̒`̂̂邪CłIntegerƂĈ@
    property PrintersCount  : Integer             read GetFPrintersCount;
    property dsPrinterName  : String              read FdsPrinterName       write FdsPrinterName;
    property PrinterNumber  : Integer             read FPrinterNumber       write SetFPrinterNumber;
    property Orientation    : TPrinterOrientation read GetFOrientation      write SetFOrientation;
    property PaperName      : String              read GetFPaperName        write SetFPaperName;
    property PaperNumber    : Integer             read GetFPaperNumber      write SetFPaperNumber;

    property DriverVersion  : Integer             read GetFDriverVersion;
    property BinName        : String              read GetFBinName          write SetFBinName;
    property BinNumber      : Integer             read GetFBinNumber        write SetFBinNumber;
    property ColorBit       : Integer             read GetFColorBit;
    property Color          : Integer             read GetColor             write SetColor;
    property Collate        : Integer             read GetCollate           write SetCollate;
    property Copies         : Integer             read GetCopies            write SetCopies;
    property Duplex         : Integer             read GetDuplex            write SetDuplex;

    property YResolution    : Integer index 1     read GetDeviceCapsValues;
    property XResolution    : Integer index 2     read GetDeviceCapsValues;
    property PaperWidth     : Integer index 3     read GetDeviceCapsValues;
    property PaperHeight    : Integer index 4     read GetDeviceCapsValues;
    property PageWidth      : Integer index 5     read GetDeviceCapsValues;
    property PageHeight     : Integer index 6     read GetDeviceCapsValues;
    property TopOffset      : Integer index 7     read GetDeviceCapsValues;
    property BottomOffset   : Integer index 8     read GetDeviceCapsValues;
    property LeftOffset     : Integer index 9     read GetDeviceCapsValues;
    property RightOffset    : Integer index 10    read GetDeviceCapsValues;

    property PrinterList          : TStringList read GetPrinterList;
    property PaperList            : TStringList read GetPaperList;
    property BinList              : TStringList read GetBinList;

    //J\bh
    //ݒľďo
    procedure CallSetting;
    //vpeBݒ_CAO̕\
    function ShowDialog : Boolean;
    //v^̐ݒ擾ăR|Ɏ捞
    procedure GetPrinterInfo(GetFlag: Boolean=False);
    //[U`p̓o^
    function SetUserPaper(UserPaperName: String; CustomW, CustomH: Integer):Boolean;
    //[U`p̍폜
    function DeleteUserPaper(UserPaperName: String): Boolean;

    //p̐ݒ(G[oBooleanōs)\bh
    function SetPaperName(PaperStr: String): Boolean;
    //pԍ̐ݒ(G[oBooleanōs)\bh
    function SetPaperNumber(Index: WORD): Boolean;
    //̐ݒ(G[oBooleanōs)\bh
    function SetOrientation(Orient: TPrinterOrientation): Boolean;
    //u̐ݒ(G[oBooleanōs)\bh
    function SetBinName(BinStr: String): Boolean;

    function ShowSetupDialog: Boolean;
    function SaveToFile(AFile: String): Boolean;
    function LoadFromFile(AFile: String): Boolean;

  published
    property Properties         : TplPrinterProperties   read FProperties;
    property PrinterName        : String                 read GetPrinterName      write SetPrinterName;
    property OnDialogClose      : TplPrtDialogCloseEvent read FOnDialogClose      write FOnDialogClose;
    property OnPrinterChange    : TNotifyEvent           read FOnPrinterChange    write FOnPrinterChange;
    property OnSetupDialogShow  : TNotifyEvent           read FOnSetupDialogShow  write FOnSetupDialogShow;
    property OnSetupDialogClose : TNotifyEvent           read FOnSetupDialogClose write FOnSetupDialogClose;
  end;

implementation

uses Math;

type
  //pXgpDp̕64(oCgUnicodeƂȊOňႤ)
  TPaperName      = array [0..63] of Char;
  TPaperNameArray = array [0..0] of TPaperName;
  PPaperNameArray = ^TPaperNameArray;

  //r̃XgpDr̕24(oCgUnicodeƂȊOňႤ)
  TBinName      = array [0..23] of Char;
  TBinNameArray = array [0..0] of TBinName;
  PBinNameArray = ^TBinNameArray;

{TplSetPrinter}

//=============================================================================
//  R|[lg̏ݒ
//=============================================================================
constructor TplSetPrinter.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  //DevModẽRs[̒lNA
  ASettings := nil;
  //DevSize0
  DevSize := 0;

  //v^擾
  FPrintersCount := GetFPrintersCount;
  FPrinterList   := TStringList.Create;
  FPaperList     := TStringList.Create;
  FBinList       := TStringList.Create;
  FPrinterName   := '';
end;

//=============================================================================
//  Loaded
//=============================================================================
procedure TplSetPrinter.Loaded;
begin
  inherited;

  if FPrintersCount = 0 then exit;

  //vpeB͏
  ChangeCurrentPrinter;

  //vpeB̐ݒDEVMODEASettingsɂݒ
  //݌vƈقȂv^(DEVMODE\)̏ꍇ́CpCpTCYԍC
  //rԍ̂ݐݒ
  SetOldPropertiesAndSettings;
end;

//=============================================================================
//  R|[lg̔j
//=============================================================================
destructor TplSetPrinter.Destroy;
begin
  FreeAndNil(FPrinterList);
  FreeAndNil(FPaperList);
  FreeAndNil(FBinList);

  DeleteObject(hPrtHandle);

  if Assigned(ASettings) then begin
    FreeMem(ASettings);
    ASettings := nil;
  end;

  inherited Destroy;
end;

//=============================================================================
//  ݌v̈ȉpublishedvpeBȊO̓ǏoƏޗp̒`
//
//  Delphi2009ȍ~UniCodeɔCDEVMODE̓Ǐ
//  DefinePropertyDefineBinaryPropertyɕύX
//  ̂߁CȑÕvWFNgNADevData̓Ǎ݃G[
//  UnicodeΉƂƂŗp҂[Ă邾낤
//
//  pTCYCCrԍ͕ʂ̃vpeBƂĂ̂ōČ
//  ASettings̓oCgz̃|C^ł邪CTMemoryStream̎gp̕ύXl
//  CƂ肠̂܂܂Ƃ
//
//  DevSize   DEVMODẼTCYDASettings̓ǏoɕKv
//  ASettings ݌vDEVMODE̓eD
//
//  PrinterName  : String;              |[g܂܂Ȃv^̖
//  Orientation  : TPrinterOrientation; 
//  PaperName    : String;              TCY
//  PaperNumber  : Integer;             pTCYԍ
//  BinNumber    : Integer;             rԍ
//  DriverVersion: Integer;             hCoo[Wԍ
//=============================================================================
procedure TplSetPrinter.DefineProperties(Filer:TFiler);
begin
  Inherited DefineProperties(Filer);

  //܂DevSizeۊǂDASettengs̓ǏoTCYɕKv
  Filer.DefineProperty('DevDataSize', ReadADevSize, WriteADevSize, True);

  Filer.DefineBinaryProperty('ADevData', ReadADev, WriteADev, True);
  Filer.DefineProperty('DesignValue', ReadDesignValues, WriteDesignValues, True);
end;

//=============================================================================
//  DevSize̕ۊ
//=============================================================================
procedure TplSetPrinter.WriteADevSize(Writer: TWriter);
begin
  Writer.WriteInteger(DevSize);
end;

//=============================================================================
//  DevSize̓Ǎ
//=============================================================================
procedure TplSetPrinter.ReadADevSize(Reader: TReader);
begin
  try
    DevSize := Reader.ReadInteger;
  except
    //Ver.9.00Õo[W̃Xg[ďo̓G[
    DevSize := 0;
  end;
end;

//=============================================================================
//  ASettings̕ۊ
//=============================================================================
procedure TplSetPrinter.WriteADev(Writer: TStream);
begin
  Writer.WriteBuffer(ASettings^,DevSize);
end;

//=============================================================================
//  ASettingsf[^̓Ǐo
//  Ǐov^̃vpeB̐ݒLoadedŎs
//
//  DefineBinaryPropertygp邱ƂŁCۊǃXg[̃TCYm
//  Ƃ\ƂȂ̂ŁC̒lDevSize̒lƂ
//=============================================================================
procedure TplSetPrinter.ReadADev(Reader: TStream);
var
  OldSize : Integer;
begin
  if Assigned(ASettings) then begin
    FreeMem(ASettings);
    ASettings := nil;
  end;
  OldSize := DevSize;
  DevSize := Reader.Size;
  if OldSize=DevSize then begin
    GetMem(ASettings,DevSize);
    try
      Reader.ReadBuffer(ASettings^, DevSize);
    except
    end;
  end;
end;

//=============================================================================
//  ݌v̊evpeBǏo
//  Âo[Wɂ͂Ȃ̂őÕo[Wō쐬vWFNgŏɓǍ
//  ގɃG[̂ŁCtry`exceptŉD
//
//  pԍCCrԍ(puԍ)͐݌v̒lɃZbg
//  vOJñvpeBǏo͂Ō
//  SetPrinterName
//  ReadDesignValues
//  Loaded
//  ̏
//
//  ۂɎgp̂́CFOrientation,FPaperNumber,FBinNumber̂
//=============================================================================
procedure TplSetPrinter.ReadDesignValues(Reader : TReader);
var
  Orient : Integer;
begin
  try
    Reader.ReadListBegin;
    FPrinterName   := Reader.ReadString;
    Orient         := Reader.ReadInteger;
    FPaperName     := Reader.ReadString;
    FPaperNumber   := Reader.ReadInteger;
    FBinNumber     := Reader.ReadInteger;
    FDriverVersion := Reader.ReadInteger;
    Reader.ReadListEnd;

    FOrientation   := TPrinterOrientation(Orient);
    FdsPrinterName := FPrinterName;
  except
  end;
end;

//=============================================================================
//  ݌ṽvpeBXg[ɕۑ
//  FPrinterNamePubulisedɂ̂Ŏۂɂ͕KvȂ
//
//  ۂɎgp̂́CFOrientation,FPaperNumber,FBinNumber̂
//  ̃R[h͐̂̃o[WgpĂvWFNgłG[Ȃ
//  悤ɂ邽߂ɂ̂܂܂ɂĂ
//=============================================================================
procedure TplSetPrinter.WriteDesignValues(Writer: TWriter);
var
  Orient : Integer;
begin
  try
    Orient := Integer(FOrientation);

    Writer.WriteListBegin;
    Writer.WriteString  (FPrinterName);
    Writer.WriteInteger (Orient);
    Writer.WriteString  (FPaperName);
    Writer.WriteInteger (FPaperNumber);
    Writer.WriteInteger (FBinNumber);
    Writer.WriteInteger (FDriverVersion);
    Writer.WriteListEnd;
  except
  end;
end;

//=============================================================================
//  PrinterCount(gp\ȃv^)vpeB擾
//=============================================================================
function TplSetPrinter.GetFPrintersCount: Integer;
var
  Flags    : Cardinal;
  dwNeeded : Cardinal;
  dwReturn : Cardinal;
  pPinfo4  : PPrinterInfo4;
begin
  dwNeeded := 0;
  dwReturn := 0;

  //v^𓾂鏀
  Flags := PRINTER_ENUM_CONNECTIONS or PRINTER_ENUM_LOCAL;

  dwNeeded := 0;
  //obt@𓾂
  EnumPrinters(Flags, nil, 4, nil, 0, dwNeeded, dwReturn);
  if dwNeeded <>0 then begin
    //\̂̔zɕKvȃoCgm
    GetMem(pPinfo4,dwNeeded);
    try
      //v^(Level=4)擾
      EnumPrinters(Flags,
                   nil,
                   4,
                   Pointer(pPinfo4),
                   dwNeeded, dwNeeded, dwReturn);
    finally
      FreeMem(pPinfo4);
    end;
  end;

  Result := dwReturn;
end;

//=============================================================================
//  PrinterName(v^)vpeB擾
//=============================================================================
function TplSetPrinter.GetPrinterName: String;
begin
  if FPrintersCount = 0 then begin
    Result := '';
  end else begin
    Result := GetPrinterNameFromString(FPrinterName);
  end;
end;

//=============================================================================
//  PrinterName(v^)vpeBݒ
//
//  v^ݒ肷ƁC̃v^݂̃v^ƂȂ
//  v^Printer.Printers[v^ԍ]Ŏ擾lŐݒ\.
//  ݂̃v^ȂPrinter.Printers[Printer.PrinterIndex].
//  󕶎Ƒ݂Ȃv^w肵ꍇ̓ftHg̃v^ɏCD
//=============================================================================
procedure TplSetPrinter.SetPrinterName(Value: String);
var
  OldPrinterName : String;
  APrinterName   : String;
begin
  if FPrintersCount = 0 then exit;

  //iKł͋v^ƌv^͓
  OldPrinterName := FPrinterName;
  APrintername   := GetPrinterNameFromString(Value);

  if APrinterName = '' then begin
    Printer.PrinterIndex := -1;
    FPrinterName         := GetPrinterNameFromString(Printer.Printers[Printer.PrinterIndex]);
  end else begin
    FPrinterName := APrinterName;
  end;

  //R|ReadingLoadingł͂̌FPrinterName̒lpDevMode
  //ǏoKv̂Ńv^̃Zbĝ
  if csReading in ComponentState then exit;
  if csLoading in ComponentState then exit;

  //FPrinterNamẽv^ɐ؊ăv^ԍ擾Ă
  //vpeB͏
  ChangeCurrentPrinter;

  //vpeB̐ݒDEVMODEASettingsɂݒ
  //قȂDEVMODE\̂̏ꍇ́CpCpTCYԍCrԍ̂ݐݒ
  SetOldPropertiesAndSettings;

  if csDesigning in ComponentState then begin
  end else begin;
    //OnPrinterChangeCxg̓v^ɕύXꍇ
    if Assigned(FOnPrinterChange) then begin
      if OldPrinterName<>FPrinterName then  FOnPrinterChange(Self);
    end;
  end;
end;

//=============================================================================
//  PrinterNumber(v^ԍ)vpeBݒ
//  v^ԍݒ肷ƁC̃v^݂̃v^ƂȂD
//  ݂Ȃv^ԍƁuBꂽv^vw肷Ɓuʏgpv
//  ^vɋIɏC
//=============================================================================
procedure TplSetPrinter.SetFPrinterNumber(const Value: Integer);
var
  OldPrinterName : String;
begin
  if FPrintersCount=0 then exit;

  OldPrinterName := FPrinterName;
  if (Value >= 0) and (Value < FPrintersCount) then begin
    FPrinterNumber := Value;
    FPrinterName   := GetPrinterNameFromString(Printer.Printers[FPrinterNumber]);
  end else begin
    //ʏgpv^{R|̃v^ɂ
    Printer.PrinterIndex := -1;
    FPrinterNumber := Printer.PrinterIndex;
    FPrinterName   := GetPrinterNameFromString(Printer.Printers[Printer.PrinterIndex]);
  end;

  ChangeCurrentPrinter;

  //vpeB̐ݒDEVMODEASettingsɂݒ
  //DEVMODE\̂Ⴄꍇ́CpCpTCYԍCrԍ̂ݐݒ
  SetOldPropertiesAndSettings;

  //OnPrinterChangeCxg̓v^ɕύXꍇ
  if Assigned(FOnPrinterChange) then begin
    if OldPrinterName <> FPrinterName then FOnPrinterChange(Self);
  end;
end;

//=============================================================================
//  ̕񂩂v^ԍ擾
//  ̃v^ɂ̓|[g܂łĂOK
//  ȂƁuBꂽv^v̏ꍇ-1Ԃ
//=============================================================================
function TplSetPrinter.GetPrinterIndexFromString(Str: String): Integer;
var
  Flags            : Cardinal;
  dwNeeded         : Cardinal;
  dwReturn         : Cardinal;
  pPinfo4          : PPrinterInfo4;
  pWork            : PPrinterInfo4;
  APrinterName     : String;
  i                : Integer;
  UpperPrinterName : String;
  UpperPrinterStr  : String;
begin
  Result := -1;
  if Str='' then exit;

  pPInfo4  := nil;
  dwNeeded := 0;
  dwReturn := 0;

  //񋓑Ώۃv^̎
  Flags := PRINTER_ENUM_LOCAL or PRINTER_ENUM_CONNECTIONS;

  //dwNeeded0ɂĕKvȃobt@TCY擾
  EnumPrinters(Flags, nil, 4, pPInfo4,dwNeeded, dwNeeded, dwReturn);

  if dwNeeded>0 then begin

    //\̂̔zɕKvȃoCgm
    GetMem(pPinfo4, dwNeeded);
    try
      if EnumPrinters(Flags,nil,4,pPinfo4,dwNeeded,dwNeeded,dwReturn) then begin
        //v^Ď擾
        FPrintersCount := dwReturn;
        pWork := pPinfo4;
        for i := 0 to dwReturn - 1 do begin
          if (pWork.Attributes and PRINTER_ATTRIBUTE_HIDDEN)=0 then begin
            APrinterName := String(pWork.pPrinterName);

            UpperPrinterName := UpperCase(APrinterName);
            UpperPrinterStr  := UpperCase(Str);
            if Pos(UpperPrinterName,UpperPrinterStr) > 0 then begin
              Result := i;
              Break;
            end;
          end;
          //̍\̂̔zɈړ
          Inc(pWork);
        end;
      end;
    finally
      FreeMem(pPinfo4);
    end;
  end;
end;

//=============================================================================
//  ̕񂩂|[gv^擾
//  ߂lv^ȊÓCGetPrinterIndexFromStrƓ
//=============================================================================
function TplSetPrinter.GetPrinterNameFromString(Str: String): String;
var
  Flags            : Cardinal;
  dwNeeded         : Cardinal;
  dwReturn         : Cardinal;
  pPinfo4          : PPrinterInfo4;
  pWork            : PPrinterInfo4;
  APrinterName     : String;
  i                : Integer;
  UpperPrinterName : String;
  UpperPrinterStr  : String;
begin
  Result := '';
  if Str='' then exit;

  pPInfo4  := nil;
  dwNeeded := 0;
  dwReturn := 0;

  //񋓑Ώۃv^̎
  Flags := PRINTER_ENUM_LOCAL or PRINTER_ENUM_CONNECTIONS;

  //dwNeeded0ɂĕKvȃobt@TCY擾
  EnumPrinters(Flags, nil, 4, pPInfo4, dwNeeded, dwNeeded, dwReturn);

  if dwNeeded>0 then begin

    //\̂̔zɕKvȃoCgm
    GetMem(pPinfo4, dwNeeded);
    try
      if EnumPrinters(Flags, nil, 4, pPinfo4, dwNeeded, dwNeeded, dwReturn) then begin
        //v^Ď擾
        FPrintersCount := dwReturn;
        pWork := pPinfo4;
        for i := 0 to dwReturn - 1 do begin
          if (pWork.Attributes and PRINTER_ATTRIBUTE_HIDDEN) = 0 then begin
            APrinterName := String(pWork.pPrinterName);

            UpperPrinterName := UpperCase(APrinterName);
            UpperPrinterStr  := UpperCase(Str);
            if Pos(UpperPrinterName,UpperPrinterStr) > 0 then begin
              Result := APrinterName;
              Break;
            end;
          end;
          //̍\̂̔zɈړ
          Inc(pWork);
        end;
      end;
    finally
      FreeMem(pPinfo4);
    end;
  end;
end;

//=============================================================================
//  DriverVersion(hCoo[W)vpeB擾
//=============================================================================
function TplSetPrinter.GetFDriverVersion: Integer;
begin
  if FPrintersCount > 0 then begin
    ADevMode := GlobalLock(hPrtHandle);
    try
      Result := ADevMode^.dmDriverVersion;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end else begin
    Result := 0;
  end;
end;

//=============================================================================
//  PaperName(p)vpeB擾
//
//  A[̗p擾s̂̂( MJ-8000C)D
//  ̌,DC_PAPERSɂ͏񂪓ĂȂ.ǂɂ邩͕s.
//
//  DeviceCapabilitie v^foCXhCo̔\͂擾Win32API֐
//  DC_PAPERSɗpTCY()̔ԍĂ.
//  ̒l,DEVMODE\̂擾pԍADevMod^.dmPaperSizev,
//  ̔ԍڂDC_PAPERNAMESpƂȂ.
//=============================================================================
function TplSetPrinter.GetFPaperName: String;
var
  PPaperNames   : PPaperNameArray;
  PPaperNumbers : PWordArray;
  Count         : Integer;
  i             : integer;
  ASizeNo       : Integer;
begin
  //Ƃ肠OȂƂ
  Result := '';
  if FPrintersCount = 0 then exit;

  ASizeNo := GetFPaperNumber;

  if ASizeNo<0 then begin
    Result := FCustomPaperName;
  end else begin
    //APortɐڑĂv^ADevice̗p̐擾
    Count := DeviceCapabilities(ADevice, APort, DC_PAPERNAMES, nil, nil);
    if Count <= 0 then exit;

    //̐pƗpԍ̔zpm
    //SizeOf(TPaperName)̒l͂UnicodeƂȊOňႤ)
    GetMem(PPaperNames,  Count*SizeOf(TPaperName));
    GetMem(PPaperNumbers,Count*SizeOf(WORD));

    try
      //mۂɗpƗpԍ
      DeviceCapabilities(ADevice, APort, DC_PAPERNAMES, PChar(PPaperNames),   nil);
      DeviceCapabilities(ADevice, APort, DC_PAPERS,     PChar(PPaperNumbers), nil);

      //Ԃɗpԍv̂𒲂ׂ
      for i := 0 to Count - 1 do begin
        //DEVMODE\̂̔ԍƈv烋[v𔲂
        if PPaperNumbers[i] = ASizeNo then begin
          Result := PPaperNames[i];
          break;
        end;
      end;
    finally
      //
      FreeMem(PPaperNames);
      FreeMem(PPaperNumbers);
    end;
  end;
end;

//=============================================================================
//  PaperName(p)vpeBݒ
//  ṕCpTCYłv^hCoɂĖ̂ႤƂ
//  Œ
//  pTCYԍŐݒ肵
//=============================================================================
procedure TplSetPrinter.SetFPaperName(const Value: String);
var
  PaperIndex : Integer;
begin
  if FPrintersCount = 0 then exit;

  //Yp΂̗pԍ擾ĂŐݒ肷
  if CheckPaperName(Value, PaperIndex) then begin
    SetFPaperNumber(PaperIndex);
  end;
end;

//=============================================================================
//  PaperNumber(pTCYԍ)vpeB擾
//  [U`p̏ꍇ́CpŃTCYłv^hCoɂ
//  ĔԍႤ
//=============================================================================
function TplSetPrinter.GetFPaperNumber: Integer;
begin
  if FPrintersCount > 0 then begin
    ADevMode := GlobalLock(hPrtHandle);
    try
      Result := ADevMode^.dmPaperSize;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end else begin
    Result := 0;
  end;
end;

//=============================================================================
//  PaperNumber(pTCYԍ)vpeBݒ
//  ṕC̗pTCYԍŐݒ肵
//=============================================================================
procedure TplSetPrinter.SetFPaperNumber(const Value: Integer);
begin
  if FPrintersCount = 0 then exit;

  ModifyOrGetDevModeBegin;
  try
    if (ADevMode^.dmFields and dm_PaperSize) <> 0 then begin
      ADevMode^.dmPaperSize := Value;
      ADevMode^.dmFields := ADevMode^.dmFields and not(DM_PAPERWIDTH or DM_PAPERLENGTH);
      //DEVMODE\̂̐ADevModeASettingsɃRs[
      ModifyDevMode(ADevMode);
    end;
  finally
    GlobalUnlock(hPrtHandle);
  end;
  Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
end;

//=============================================================================
//  Orientation(̕)vpeB擾
//=============================================================================
function TplSetPrinter.GetFOrientation: TPrinterOrientation;
begin
  if FPrintersCount > 0 then begin
    ADevMode := GlobalLock(hPrtHandle);
    try
      if ADevMode^.dmOrientation = DMORIENT_PORTRAIT then begin
        Result := poPortrait;
      end else begin
        Result := poLandscape;
      end;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end else begin
    Result := poPortrait;
  end;
end;

//=============================================================================
//  Orientation(̕)vpeBݒ
//  ݒ\Ȓl͈ȉ2̂
//  poPortrait  c
//  poLandscape 
//=============================================================================
procedure TplSetPrinter.SetFOrientation(const Value: TPrinterOrientation);
begin
  if FPrintersCount = 0 then exit;

  ModifyOrGetDevModeBegin;
  try
    if (ADevMode^.dmFields and dm_Orientation) <> 0 then begin
      if Value=poPortrait  then ADevMode^.dmOrientation := DMORIENT_PORTRAIT;
      if Value=poLandscape then ADevMode^.dmOrientation := DMORIENT_LANDSCAPE;
      //DEVMODE\̂̐ADevModeASettingsɃRs[
      ModifyDevMode(ADevMode);
    end;
  finally
    GlobalUnlock(hPrtHandle);
  end;
  Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
end;

//=============================================================================
//  BinName(r)vpeB擾
//=============================================================================
function TplSetPrinter.GetFBinName: String;
var
  PBinNames   : PBinNameArray;
  PBinNumbers : PWordArray;
  Count       : Integer;
  i           : Integer;
  ABinNo      : Integer;
begin
  //Ƃ肠OȂƂ
  Result := '';
  if FPrintersCount = 0 then exit;

  ABinNo := GetFBinNumber;

  //APortɐڑĂv^ADevicẽr̐擾
  Count := DeviceCapabilities(ADevice, APort, DC_BINS, nil, nil);
  if Count <= 0 then exit;

  //̐r̂ƃrԍ̔zpɊm
  //SizeOf(TBinName)̒l͂UnicodeƂȊOňႤ)
  GetMem(PBinNames,  Count*SizeOf(TBinName));
  GetMem(PBinNumbers,Count*SizeOf(WORD));

  try
    //mۂɃr̂ƃrԍ
    DeviceCapabilities(ADevice, APort, DC_BINNAMES, PChar(PBinNames),   nil);
    DeviceCapabilities(ADevice, APort, DC_BINS,     PChar(PBinNumbers), nil);

    //ԂɃrԍv̂𒲂ׂ
    for i := 0 to Count - 1 do begin
      //DEVMODE\̂̔ԍƈv烋[v𔲂
      if PBinNumbers[i] = ABinNo then begin
        Result := PBinNames[i];
        break;
      end;
    end;
  finally
    //
    FreeMem(PBinNumbers);
    FreeMem(PBinNames);
  end;
end;

//=============================================================================
//  BinName(r)vpeBݒ
//=============================================================================
procedure TplSetPrinter.SetFBinName(const Value: String);
var
  PBinNames   : PBinNameArray;
  PBinNumbers : PWordArray;
  Count       : Integer;
  i           : Integer;
  ABinNum     : Integer;
  Flag        : Boolean;
begin
  ABinNum := 0;
  if FPrintersCount=0 then exit;

  ModifyOrGetDevModeBegin;
  GlobalUnlock(hPrtHandle);

  Printer.GetPrinter(ADevice, ADriver, APort, hPrtHandle);

  //rXg瑶݂`FbN
  Count := DeviceCapabilities(ADevice,APort,DC_BINS,nil,nil);
  if Count <= 0 then exit;

  Flag := False;
  //̐r̂ƃrԍ̔zpɊm
  //SizeOf(TBinName)̒l͂UnicodeƂȊOňႤ)
  GetMem(PBinNames,  Count*SizeOf(TBinName));
  GetMem(PBinNumbers,Count*SizeOf(WORD));

  try
    //mۂɃr̂ƃrԍ
    DeviceCapabilities(ADevice, APort, DC_BINNAMES, PChar(PBinNames),   nil);
    DeviceCapabilities(ADevice, APort, DC_BINS,     PChar(PBinNumbers), nil);

    //ԂɃrԍv̂𒲂ׂ
    for i := 0 to Count - 1 do begin
      if Value=PBinNames[i] then begin
        ABinNum := PBinNumbers[i];
        Flag    := True;
        break;
      end;
    end;
  finally
    FreeMem(PBinNumbers);
    FreeMem(PBinNames);
  end;
  if Flag then SetFBinNumber(ABinNum);
end;

//=============================================================================
//  BinNunmber(rԍ)vpeB擾
//=============================================================================
function TplSetPrinter.GetFBinNumber: Integer;
begin
  if FPrintersCount > 0 then begin
    ADevMode := GlobalLock(hPrtHandle);
    try
      Result := ADevMode^.dmDefaultSource;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end else begin
    Result := 0;
  end;
end;

//=============================================================================
//  BinNunmber(rԍ)vpeBݒ
//=============================================================================
procedure TplSetPrinter.SetFBinNumber(const Value: Integer);
begin
  if FPrintersCount = 0 then exit;

  ModifyOrGetDevModeBegin;
  try
    if (ADevMode^.dmFields and dm_DefaultSource) <> 0 then begin
      ADevMode^.dmDefaultSource := Value;
      //DEVMODE\̂̐ADevModeASettingsɃRs[
      ModifyDevMode(ADevMode);
    end;
  finally
    GlobalUnlock(hPrtHandle);
  end;
  Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
end;

//=============================================================================
//  ColorBit(J[rbg)vpeB擾
//  ColorBitvpeB͓Ǐop
//  J[@\ĂmNɐݒ肵Ă0.J[@\Ȃ0
//=============================================================================
function TplSetPrinter.GetFColorBit: Integer;
begin
  if FPrintersCount > 0 then begin
    ADevMode := GlobalLock(hPrtHandle);
    try
      if ADevMode^.dmColor = DMCOLOR_COLOR then begin
        Result :=GetDeviceCaps(Printer.Handle, BITSPIXEL) * GetDeviceCaps(Printer.Handle, PLANES);
      end else begin
        Result := 0;
      end;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end else begin
    Result := 0;
  end;
end;

//=============================================================================
//  Color(J[EmN)vpeB擾
//  l͈ȉ̂Âꂩ
//  DMCOLOR_MONOCHROME
//  DMCOLOR_COLOR
//=============================================================================
function TplSetPrinter.GetColor: Integer;
begin
  if FPrintersCount > 0 then begin
    ADevMode := GlobalLock(hPrtHandle);
    try
      Result := ADevMode^.dmColor;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end else begin
    Result := DMCOLOR_MONOCHROME;
  end;
end;

//=============================================================================
//  Color(J[EmN)vpeBݒ
//  l͈ȉ̂Âꂩ
//  DMCOLOR_MONOCHROME
//  DMCOLOR_COLOR
//=============================================================================
procedure TplSetPrinter.SetColor(const Value: Integer);
begin
  if FPrintersCount = 0 then exit;

  ModifyOrGetDevModeBegin;
  try
    if (ADevMode^.dmFields and dm_Color) <> 0 then begin
      ADevMode^.dmColor := Value;
      //DEVMODE\̂̐ADevModeASettingsɃRs[
      ModifyDevMode(ADevMode);
    end;
  finally
    GlobalUnlock(hPrtHandle);
  end;
  Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
end;

//=============================================================================
//  Collate(Pʂň)vpeB擾
//  l͈ȉ̂Âꂩ
//  DMCOLLATE_TRUE
//  DMCOLLATE_FALSE
//=============================================================================
function TplSetPrinter.GetCollate: Integer;
begin
  if FPrintersCount > 0 then begin
    ADevMode := GlobalLock(hPrtHandle);
    try
      Result := ADevMode^.dmCollate;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end else begin
    Result := DMCOLLATE_FALSE;
  end;
end;

//=============================================================================
//  Collate(Pʂň)vpeBݒ
//  ݒ\Ȓl͈ȉ̂Âꂩ
//  DMCOLLATE_TRUE
//  DMCOLLATE_FALSE
//  1̎͐ݒsD2ȏ̎͐Ɉݒ肵ĂD
//
//  [vpeB]̃_CAOɂ[Pʂň]邪CDevModeł͓Ǐł
//  hCoD
//  ̂悤ȃv^ł͈̃[`ŃV~[gKvD
//=============================================================================
procedure TplSetPrinter.SetCollate(const Value: Integer);
begin
  if FPrintersCount = 0 then exit;

  ModifyOrGetDevModeBegin;
  try
    if (ADevMode^.dmFields and dm_Collate) <> 0 then begin
      if ADevMode^.dmCopies>= 2 then begin
        ADevMode^.dmCollate := Value;
        //DEVMODE\̂̐ADevModeASettingsɃRs[
        ModifyDevMode(ADevMode);
      end;
    end;
  finally
    GlobalUnlock(hPrtHandle);
  end;
  Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
end;

//=============================================================================
//  Copies()vpeB擾
//=============================================================================
function TplSetPrinter.GetCopies: Integer;
begin
  if FPrintersCount > 0 then begin
    ADevMode := GlobalLock(hPrtHandle);
    try
      Result := ADevMode^.dmCopies;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end else begin
    Result := 1;
  end;
end;

//=============================================================================
//  Copies()vpeBݒ
//=============================================================================
procedure TplSetPrinter.SetCopies(const Value: Integer);
begin
  if FPrintersCount = 0 then exit;

  ModifyOrGetDevModeBegin;
  try
    if (ADevMode^.dmFields and dm_Copies) <> 0 then begin
      ADevMode^.dmCopies := Value;
      //1͕̎Pʂ͖̈
      if Value <= 1 then begin
        if (ADevMode^.dmFields and dm_Collate) <> 0 then begin
          ADevMode^.dmCollate := DMCOLLATE_FALSE;
        end;
      end;
      //DEVMODE\̂̐ADevModeASettingsɃRs[
      ModifyDevMode(ADevMode);
    end;
  finally
    GlobalUnlock(hPrtHandle);
  end;
  Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
end;

//=============================================================================
//  Duplex(ʈ)vpeB擾
//  l͈ȉ̂Âꂩ
//  DMDUP_SIMPLEX
//  DMDUP_HORIZONTAL
//  DMDUP_VERTICAL
//=============================================================================
function TplSetPrinter.GetDuplex: Integer;
begin
  if FPrintersCount > 0 then begin
    ADevMode := GlobalLock(hPrtHandle);
    try
      Result := ADevMode^.dmDuplex;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end else begin
    Result := DMDUP_SIMPLEX;
  end;
end;

//=============================================================================
//  Duplex(ʈ)vpeBݒ
//=============================================================================
procedure TplSetPrinter.SetDuplex(const Value: Integer);
begin
  if FPrintersCount = 0 then exit;

  ModifyOrGetDevModeBegin;
  try
    if (ADevMode^.dmFields and dm_Duplex) <> 0 then begin
      ADevMode^.dmDuplex := Value;
      //DEVMODE\̂̐ADevModeASettingsɃRs[
      ModifyDevMode(ADevMode);
    end;
  finally
    GlobalUnlock(hPrtHandle);
  end;
  Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
end;

//=============================================================================
//  ȉ̃vpeB̎擾p̋ʊ֐
//
//  ADevMoe^.͎擾ȂD݂̃v^nh擾DADevMode^.
//  ̎擾ƈ̃R[hɉ𑜓xKvȎɗOĂ܂D
//  (v^̃nhbN邽)
//  ͑̃vpeBDݒR[hsɂ͎gps
//
//  R|(v^)̐؊͍sĂȂ̂ŕTpSetPrintergpĂꍇ
//  ͒ӂKvDȉ̃XgQl̂ƁD
//  ֌W̃Avł͗p擾KvD̎擾ɎԂ
//  ƃAv̎sxɉe邽߁C̎dlƂȂĂD
//
//-----------------------------------------------------------------------------
//
//  1. XResolution(𑜓x)vpeB
//  2. YResolution(c𑜓x)vpeB
//  3. PeperWidth(p)vpeB
//  4. PagperHeight(pE)vpeB
//  5. PageWidth(\)vpeB
//  6. PageHeight(\E)vpeB
//  7. TopOffset([ItZbg)vpeB
//  8. BottomOffset([ItZbgl)vpeB
//  9. LeftOffset([ItZbgl)vpeB
//  10.RightOffset(E[ItZbg)vpeB
//=============================================================================
function TplSetPrinter.GetDeviceCapsValues(const Index: Integer): Integer;
begin
  Result := 0;
  if FPrintersCount > 0 then begin
    case Index of
      //Əc̉𑜓x
      1:  Result := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
      2:  Result := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
      //pƍ
      3:  Result := GetDeviceCaps(Printer.Handle, PHYSICALWIDTH);
      4:  Result := GetDeviceCaps(Printer.Handle, PHYSICALHEIGHT);
      //\̈̕ƍ
      5:  Result := GetDeviceCaps(Printer.Handle, HORZRES);
      6:  Result := GetDeviceCaps(Printer.Handle, VERTRES);
      //㉺ẼItZbg
      7:  Result := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETY);
      8:  Result := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETY) + GetDeviceCaps(Printer.Handle, VERTRES);
      9:  Result := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETX);
      10: Result := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETX)+GetDeviceCaps(Printer.Handle, HORZRES);
    end;
  end;
end;

//=============================================================================
//  p̐ݒ̌J(EQlp)\bh
//  ̗pZbgȂꍇFalseԂ
//=============================================================================
function TplSetPrinter.SetPaperName(PaperStr: String): Boolean;
begin
  SetFPaperName(PaperStr);
  Result := PaperStr = GetFPaperName;
end;

//=============================================================================
//  pԍŗpݒ肷J(EQlp)\bh
//  pԍ(DM_PAPER_A4Ȃǂ̒萔)ŗpTCYݒ肷
//  Ŏw肷pԍ̗pȂꍇFalseԂ
//=============================================================================
function TplSetPrinter.SetPaperNumber(Index: WORD): Boolean;
begin
  SetFPaperNumber(Index);
  Result := Index=GetFPaperNumber;
end;

//=============================================================================
//  ݒ肷J(EQlp)\bh
//  ۂɂ͗ṕ̕CPrinter.Orientation := poLandscape; ƂR[hŐݒ
//  \Ȃ̂ŁC̃\bh͕svD
//  T|[gĂȂꍇFalseԂ
//=============================================================================
function TplSetPrinter.SetOrientation(Orient: TPrinterOrientation): Boolean;
begin
  SetFOrientation(Orient);
  Result :=Orient=GetFOrientation;
end;
//=============================================================================
//  u(r)ݒ肷J(EQlp)\bh
//  BinStrŎw肷ruɐݒ肷
//  T|[gĂȂr̂^FalseԂ
//=============================================================================
function TplSetPrinter.SetBinName(BinStr: String): Boolean;
begin
  SetFBinName(BinStr);
  Result := BinStr=GetFBinName;
end;

//=============================================================================
//  s̃[U`p쐬\bh
//
//  UserPaperName pXgɕ\p̕.63ȓ
//  CustomW  p̕0.1mmPʂŎw
//           (FORM_INFO_1\̂ł1/1000Ŏw肷)
//  CustomH  p̍0.1mmPʂŎw()
//=============================================================================
function TplSetPrinter.SetUserPaper(UserPaperName: String; CustomW,
  CustomH: Integer): Boolean;
begin
  Result := False;
  if FPrintersCount = 0 then exit;

  //WindowsNTn̂ݏ
  if Win32Platform=VER_PLATFORM_WIN32_NT then begin
    SetUserPaperNT(UserPaperName, CustomW, CustomH);
    Result := CheckSetUserPaper(CustomW, CustomH);
  end;

  if Result then begin
    if FCustomPaperName = '' then FCustomPaperName := USerPaperName;
  end else begin
    FCustomPaperName := '';
  end;
end;

//=============================================================================
//  [U`p쐬֌W\bh
//
//  p̃TCYĎ擾ă[U`p̐`FbN
//  pZbgĂĂTCYݒɎsĂꍇ̂ŃTCY
//  mFD
//=============================================================================
function TplSetPrinter.CheckSetUserPaper(CustomW,CustomH: Integer): Boolean;
var
  Temp     : Integer;
  APaperW  : Integer;
  APaperH  : Integer;
  DeffSize : Integer;
begin
  APaperW := Ceil(GetDeviceCapsValues(3) * 254.0 / GetDeviceCapsValues(1));
  APaperH := Ceil(GetDeviceCapsValues(4) * 254.0 / GetDeviceCapsValues(2));

  DeffSize := 2;
  //̌̎͏ctƂȂ
  if GetFOrientation = poLandscape then begin
    Temp    := APaperW;
    APaperW := APaperH;
    APaperH := Temp;
  end;

  //vX}CiX2ȓ琬Ƃ
  Result := (APaperW <= (CustomW+DeffSize)) and (APaperW >= (CustomW-DeffSize)) and
            (APaperH <= (CustomH+DeffSize)) and (APaperH >= (CustomH-DeffSize));
end;

//=============================================================================
//  [U`p̍쐬
//  WindowsNT4(SP6),Windows2000(SP2)̃[`
//  PowerUser(ʃ[U)ȏłȂƃ[U`p̍쐬͕s
//  Ƀ[U`p쐬ς݂łUsersłSetForm\(݂̃v^
//  pXgǉ\)
//=============================================================================
function TplSetPrinter.SetUserPaperNT(UserPaperName: String; CustomW,
  CustomH: Integer): Boolean;
var
  hPrt      : THandle;
  pCustName : TPaperName;
  Info_1    : TFORMINFO1;
  pInfo_1   : Pointer;
  Pdef      : PRINTER_DEFAULTS;
  fgPaper   : Boolean;
  SizeNo    : Integer;
begin
  strPCopy(pCustName,UserPaperName);
  pInfo_1 := @Info_1;

  Printer.GetPrinter(ADevice, ADriver, APort, hPrtHandle);

  //WindowsNT,2000̏ꍇANZXKv
  //Ǘ҂̌ŃT[õvpeBɗpǉ
  ZeroMemory(@Pdef, Sizeof(PRINTER_DEFAULTS));
  Pdef.DesiredAccess := PRINTER_ALL_ACCESS;
  OpenPrinter(ADevice, hPrt, @Pdef);

  //p̗L`FbN
  fgPaper := CheckPaperName(UserPaperName, SizeNo);
  try
    Info_1.Flags         := FORM_USER;
    Info_1.pName         := PChar(UserPaperName);
    Info_1.Size.cx       := CustomW*100;
    Info_1.Size.cy       := CustomH*100;
    Info_1.ImageableArea := Rect(0, 0, CustomW*100, CustomH*100);
    //ݒ肷ׂpTCY݂ꍇ̓TCŶݐݒ
    //ݒ肷ׂpTCY݂ꍇ͂̂܂܎gpl
    if fgPaper then begin
      SetForm(hPrt, pCustName, 1, pInfo_1);
    //ݒ肷ׂpTCY݂Ȃꍇ͗p쐬
    end else begin
      //xpTCY͈͊OŐݒ肷Ƒ݂płXgɏoȂ
      //SetFormsƕ\
      //AddFormSetForm˂Ă炵
      if AddForm(hPrt, 1, pInfo_1) = False then begin
        SetForm(hPrt, pCustName, 1, pInfo_1);
      end;
    end;
  finally
    ClosePrinter(hPrt);
  end;

  ModifyOrGetDevModeBegin;

  //݂̃v^ɗpǉ
  strPCopy(ADevMode^.dmFormName, UserPaperName);
  //ǉꂽp̔ԍSizeNoɎ擾
  Result := CheckPaperName(UserPaperName, SizeNo);
  if Result = False then SizeNo := DMPAPER_USER;

  try
    try
      //pԍƃTCYDEVMODE\̂ɃZbg
      //dmPaperSize̎_ŃZbgȂhCo(쐬[v
      //^̐ݒ]_CAO̗pɍ쐬pIԂɂɂȂ
      //Ȃ)CdmFields̃tOSĊO(ỸR[h폜)OK̂悤
      //łD
      ADevMode^.dmPaperSize   := SizeNo;
      ADevMode^.dmPaperLength := CustomH;
      ADevMode^.dmPaperWidth  := CustomW;
      FCustomPaperName        := UserPaperName;

      //DEVMODE\̂̐ADevModeASettingsɃRs[
      ModifyDevMode(ADevMode);
    except
      Result := False;
    end;
  finally
    GlobalUnlock(hPrtHandle);
  end;

  Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);

  //AddFormŒǉĂ,XgŌȂp͍폜Ă
  if Result = False then DeleteUserPaper(UserPaperName);
end;

//=============================================================================
//  [U`p̍폜
//  AdministratorsłȂƍ폜s̗lł
//  Windows96,98̏ꍇ͏True(ۂɍ폜킯ł͂Ȃ),`pȂꍇ
//  False
//  v^ʂ̖{R|Ń[U`ĂꍇCAvsɗp
//  폜Ɨp̐ݒ肪ҒʂɂȂȂD
//=============================================================================
function TplSetPrinter.DeleteUserPaper(UserPaperName: String): Boolean;
var
  hPrt    : THandle;
  Pdef    : PRINTER_DEFAULTS;
  fgPaper : Boolean;
  SizeNo  : Integer;
begin
  Result := False;
  if FPrintersCount=0 then exit;

  Printer.GetPrinter(ADevice, ADriver, APort, hPrtHandle);

  if Win32Platform = VER_PLATFORM_WIN32_NT then begin
    //WindowsNT,2000̏ꍇANZXKv
    ZeroMemory(@Pdef, Sizeof(PRINTER_DEFAULTS));
    Pdef.DesiredAccess := PRINTER_ALL_ACCESS;

    OpenPrinter(ADevice, hPrt, @Pdef);
    //p̗L`FbN
    fgPaper := CheckPaperName(UserPaperName, SizeNo);
    try
      if fgPaper then begin
        Result := DeleteForm(hPrt, PChar(UserPaperName));
      end else begin
        Result := False;
      end;
    finally
      ClosePrinter(hPrt);
    end;
  end else begin
    Result := True;
  end;

  if Result then begin
    FCustomPaperName := '';
  end else begin
  end;
end;

//=============================================================================
//  [U`p쐬֌W\bh
//
//  w̗p邩̃`FbN
//  SetCustPaperŎgp
//=============================================================================
function TplSetPrinter.CheckPaperName(UserPaperName: String; var pNo: Integer): Boolean;
var
   PPaperNames   : PPaperNameArray;
   PPaperNumbers : PWordArray;
   Count         : Integer;
   i             : Integer;
   fgPaperName   : String;
   S             : String;
begin
  Result := False;
  if FPrintersCount=0 then exit;

  pNo := -1;
  //p
  fgPaperName := UserPaperName;
  //APortɐڑĂv^ADevice̗p̐擾

  Count := DeviceCapabilities(ADevice, APort, DC_PAPERNAMES, nil, nil);
  //̐pƗpԍ̔zpm
  //SizeOf(TPaperName)̒l͂UnicodeƂȊOňႤ)
  GetMem(PPaperNames,  Count*SizeOf(TPaperName));
  GetMem(PPaperNumbers,Count*SizeOf(WORD));

  try
    //mۂɗpƗpԍ
    DeviceCapabilities(ADevice, APort, DC_PAPERNAMES, PChar(PPaperNames),   nil);
    DeviceCapabilities(ADevice, APort, DC_PAPERS,     PChar(PPaperNumbers), nil);

    //Ԃɗpv̂𒲂ׂ
    for i := 0 to Count - 1 do begin
      S :=  PPaperNames[i];
      if fgPaperName = S then begin
        Result := True;
        pNo    := PPaperNumbers[i];
        break;
      end;
    end;
  finally
    //
    FreeMem(PPaperNames);
    FreeMem(PPaperNumbers);
  end;
end;

//=============================================================================
//  PritnerList(Ǐop)vpeBp
//  v^ꗗ擾DXg̓v^ԍł͂ȂABC
//  v^ꗗFPrinterNameListɃv^ԍɃZbg
//
//  PrinterInfoLevel=4(NTn)̏ꍇ̂ݏ
//=============================================================================
function TplSetPrinter.GetPrinterList: TStringList;
var
  Flags     : Cardinal;
  dwNeeded  : Cardinal;
  dwReturn  : Cardinal;
  pPinfo4   : PPrinterInfo4;
  pWork     : PPrinterInfo4;
  S         : String;
  i         : Integer;
begin
  //Xg
  FPrinterList.Clear;

  pPInfo4  := nil;
  dwNeeded := 0;
  dwReturn := 0;

  //񋓑Ώۃv^̎
  Flags := PRINTER_ENUM_LOCAL or PRINTER_ENUM_CONNECTIONS;

  //dwNeeded0ɂĕKvȃobt@TCY擾
  EnumPrinters(Flags, nil, 4, pPInfo4, dwNeeded, dwNeeded, dwReturn);

  if dwNeeded > 0 then begin

    //\̂̔zɕKvȃoCgm
    GetMem(pPinfo4, dwNeeded);
    try
      if EnumPrinters(Flags, nil, 4, pPinfo4, dwNeeded, dwNeeded, dwReturn) then begin
        //v^Ď擾
        FPrintersCount := dwReturn;
        pWork := pPinfo4;
        for i := 0 to dwReturn - 1 do begin
          if (pWork.Attributes and PRINTER_ATTRIBUTE_HIDDEN) = 0 then begin
            S := String(pWork.pPrinterName);
            FPrinterList.Add(S);
          end;
          //̍\̂̔zɈړ
          Inc(pWork);
        end;
      end;
    finally
      FreeMem(pPinfo4);
    end;
  end;

  FPrinterList.Sort;
  Result := FPrinterList;
end;

//=============================================================================
//  PaperList(Ǐop)vpeBp
//  pTCYꗗ擾
//=============================================================================
function TplSetPrinter.GetPaperList: TStringList;
var
  PPaperNames : PPaperNameArray;
  Count       : Integer;
  i           : Integer;
begin
  //Xgɂ
  FPaperList.Clear;

  if FPrintersCount > 0 then begin
    ModifyOrGetDevModeBegin;
    try
      //APortɐڑĂv^ADevice̗p̐擾
      Count := DeviceCapabilities(ADevice, APort, DC_PAPERNAMES, nil, nil);

      if Count > 0 then begin
        //̐pƗpԍ̔zpm
        //SizeOf(TPaperName)̒l͂UnicodeƂȊOňႤ)
        GetMem(PPaperNames, Count * SizeOf(TPaperName));
        try
          //mۂɗp
          DeviceCapabilities(ADevice, APort, DC_PAPERNAMES, PChar(PPaperNames), nil);
          for i := 0 to Count - 1 do begin
            FPaperList.Add(PPaperNames[i]);
          end;
        finally
          FreeMem(PPaperNames);
        end;
      end;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end;

  Result := FPaperList;
end;

//=============================================================================
//  BinList(Ǐop)vpeBp
//  üꗗ擾
//
//  DeviceCapabilities
//  http://msdn.microsoft.com/ja-jp/library/cc428443(lightweight).aspx
//=============================================================================
function TplSetPrinter.GetBinList: TStringList;
var
  PBinNames : PBinNameArray;
  Count     : Integer;
  i         : integer;
begin
  //Xgɂ
  FBinList.Clear;

  if FPrintersCount > 0 then begin
    ModifyOrGetDevModeBegin;
    try
      //APortɐڑĂv^ADevicẽr̐擾
      Count := DeviceCapabilities(ADevice, APort, DC_BINS, nil, nil);

      if (Count>0) then begin
        //̐r̂̔zpm
        //SizeOf(TBinName)̒l͂UnicodeƂȊOňႤ)
        GetMem(PBinNames, Count * SizeOf(TBinName));
        try
          //mۂɃr̂
          DeviceCapabilities(ADevice, APort, DC_BINNAMES, PChar(PBinNames), nil);
          //ԂɃr̂̕Xgɑ
          //͓̕płhCoɂĈႤꍇ
          for i := 0 to Count - 1 do begin
            FBinList.Add(PBinNames[i]);
          end;
        finally
          //
          FreeMem(PBinNames);
        end;
      end;
    finally
      GlobalUnlock(hPrtHandle);
    end;
  end;

  Result := FBinList;
end;

//=============================================================================
//  R|[lgwt@Cɕۑ
//=============================================================================
function TplSetPrinter.SaveToFile(AFile: String): Boolean;
var
  AStream : TFileStream;
begin
  Result := False;
  if FPrintersCount = 0 then exit;

  AStream := TFileStream.Create(AFile, fmCreate or fmShareDenyNone);
  try
    try
      AStream.WriteComponent(Self);
      Result := True;
    except
      Result := False;
    end;
  finally
    AStream.Free;
  end;
end;

//=============================================================================
//  R|[lgt@CǏo
//  ̃\bhśCR|FPrinterNamẽv^݂̃v^ƂȂ
//  evpeBlōĐݒ肳D
//=============================================================================
function TplSetPrinter.LoadFromFile(AFile: String): Boolean;
var
  AStream : TFileStream;
begin
  Result := False;
  if FPrintersCount = 0 then exit;

  //Yt@CȂFalseŏI
  if not FileExists(AFile) then exit;

  AStream := TFileStream.Create(AFile, fmOpenRead or fmShareDenyNone);
  try
    try
      AStream.ReadComponent(Self);
      Result := True;
    except
      Result := False;
    end;
  finally
    AStream.Free;
  end;
end;

//=============================================================================
//  FNamePrinter̃v^݂̃v^ɐݒ
//  evpeB͂̃v^̃ftHg̐ݒƂȂD
//  v^Cv^ԍύXƂȂɎsKvD
//
//  ylz
//  v^̃ftHgl擾3s̈Ӗ
//
//  (1) Printer.GetPrinter(ADevice,ADriver,APort,hPrtHandle);
//  (2) Printer.SetPrinter(ADevice,ADriver,APort,0);
//  (3) Printer.GetPrinter(ADevice,ADriver,APort,hPrtHandle);
//
//  (1) GetPrinterŎ擾łADevMode͕ύXO()̒l
//      ADevice,ADriver͕ύX̒l
//  (2) SetPrinterhPrtHandle0w肷ƕύX(ftHg)ADevModel
//      擾ł
//  (3) SetPrinterŎ擾͂AdevMode(ftHgl)ۂɎ擾ł
//=============================================================================
procedure TplSetPrinter.ChangeCurrentPrinter;
begin
  FPrinterNumber       := GetPrinterIndexFromString(FPrinterName);
  Printer.PrinterIndex := FPrinterNumber;
  Printer.GetPrinter(ADevice, ADriver, APort, hPrtHandle);
  Printer.SetPrinter(ADevice, ADriver, APort, 0);

  if FPrinterNumber = -1 then begin
    FPrinterName   := GetPrinterNameFromString(Printer.Printers[Printer.PrinterIndex]);
    FPrinterNumber := Printer.PrinterIndex;
  end;

  //GetPrinter͂̃\bhďoɌďoŎs
end;

//=============================================================================
//  evpeB݂̏ƓǏo̍ۂɎs
//  GlobalLook(hPrtHandle)sĂ̂ŁCKGlobalUnlock(hPrtHandle)Kv
//=============================================================================
procedure TplSetPrinter.ModifyOrGetDevModeBegin;
var
  PrtName : String;
begin
  //v^ςĂȂ`FbN
  //ςĂ猻݂̃v^{R|FPrinterNamẽv^ɕύX
  PrtName := GetPrinterNameFromString(Printer.Printers[Printer.PrinterIndex]);

  if PrtName <> FPrinterName then ChangeCurrentPrinter;
  SetOldPropertiesAndSettings;

  Printer.GetPrinter(ADevice, ADriver, APort, hPrtHandle);
  ADevMode := GlobalLock(hPrtHandle);
end;

//=============================================================================
//  DocumentPropertiesp̋ʃ\bh
//  evpeBdmXXXXɐݒ肵CDEVMODE\̂̐̂߂Ɏs
//=============================================================================
procedure TplSetPrinter.ModifyDevMode(Value: PDeviceMode);
var
  hPrt : THandle;
  Mode : DWORD;
begin
  OpenPrinter(ADevice, hPrt, nil);
  Mode := DM_MODIFY or DM_COPY;
  try
    DocumentProperties(Application.Handle, hPrt, ADriver, Value^,Value^, Mode);
    GetPropertiesAndSettings;
  finally
    ClosePrinter(hPrt);
  end;
end;

//=============================================================================
//  ݂̃v^̏擾  J\bh
//  ݂̃v^̐ݒlv^{R|̐ݒlƂ
//  [v^̐ݒ][]_CAOł̐ݒe擾邽߂̂
//
//  Flag=Truȅꍇ
//  ݂̃v^̃ftHglŏDv^ς
//
//  Flag=Falsȅꍇ
//  (1)݂̃v^R|ێĂv^ƈႤꍇ
//     ݂̃v^̐ݒl{R{̃v^̐ݒlƂȂ
//     v^݂̃v^ƓƂȂ
//  (2)݂̃v^ƃR|ێĂv^Ɠꍇ
//     ݂̃v^̐ݒl{R|̐ݒlƂȂ
//=============================================================================
procedure TplSetPrinter.GetPrinterInfo(GetFlag: Boolean=False);
var
  AIndex : Integer;
begin
  if FPrintersCount = 0 then exit;

  AIndex := Printer.PrinterIndex;
  //v^݂̃v^̃ftHglŏ
  FPrinterName := GetPrinterNameFromString(Printer.Printers[AIndex]);

  if GetFlag then begin
    //FPrinterNamẽv^ɐ؊ăv^ԍ擾Ă
    //vpeB͏
    ChangeCurrentPrinter;
  end else begin
    //݂̃vpeBASettingsޔ
    GetPropertiesAndSettings;

    if FPrinterName <> FdsPrinterName then begin
      //FPrinterNamẽv^ɐ؊ăv^ԍ擾Ă
      //vpeB͏
      ChangeCurrentPrinter;

      //擾vpeBŖ{R|̃v^ݒ
      SetOldPropertiesAndSettings;
    end else begin
      //vpeB̐ݒDEVMODEASettingsɂݒ
      SetOldPropertiesAndSettings;
    end;
  end;
end;

//=============================================================================
//  ݂̃v^̃vpeBDevMode\̂̑ޔ
//
//  vpeB
//  
//  pTCYԍ
//  rr
//  ݂̂擾
//
//  DevMode\̂́CASettingsƂɑޔčŐV̏擾Ă
//=============================================================================
procedure TplSetPrinter.GetPropertiesAndSettings;
begin
  if FPrintersCount = 0 then exit;

  Printer.GetPrinter(ADevice, ADriver, APort, hPrtHandle);

  //ASettingsDevSize̒l݂͌hPrtHandleĎ擾
  if Assigned(ASettings) then begin
    FreeMem(ASettings);
    ASettings := nil;
  end;

  ADevMode := GlobalLock(hPrtHandle);
  DevSize  := GlobalSize(hPrtHandle);
  try
    GetMem(ASettings, DevSize);
    System.Move(ADevMode^, ASettings^, DevSize);

    if ADevMode^.dmOrientation=DMORIENT_PORTRAIT then begin
      FOrientation := poPortrait;
    end else begin
      FOrientation := poLandscape;
    end;
    FPaperNumber := ADevMode^.dmPaperSize;
    FBinNumber   := ADevMode^.dmDefaultSource;
  finally
    GlobalUnlock(hPrtHandle);
  end;
end;

//=============================================================================
//  v^̐ݒ(DevModeݒ)  J\bh
//
//  ݂̃v^Õv^(N͐݌ṽv^)ƓȂ
//  ݂̃v^DevModeɑÕv^DevMode(ASettings̒l)Rs[Đ
//  肵Ȃ
//  Cv^hCoȂǂ̈Ⴂꍇ͎sȂ
//  v^hCöႢ̔DevMode\̂̃TCYōs
//
//  قȂv^̏ꍇ́C
//  
//  pTCYԍ
//  rr
//  ݂̂ݒ肷
//
//  Win32API̐łDevSize̎擾DocumentPropertiesMode=0 ɂLڂ
//  邪Ĉ݂ƂGlobalSizeŎ擾TCYƕωȂ̂łgp
//  D
//
//  ADevice    v^@@@@@@@@
//  ADriver    hCo
//  APort      |[g
//  hPrtHandle v^hCõnh
//=============================================================================
function TplSetPrinter.SetOldPropertiesAndSettings : Boolean;
var
  OldDevSize : Integer;
begin
  Result := True;
  if FPrintersCount = 0 then exit;

  if FdsPrinterName = FPrinterName then begin
    Printer.GetPrinter(ADevice, ADriver, APort, hPrtHandle);
    //nhhPrtHandlebN,ŏ̃oCg̃|C^ADevMode擾
    OldDevSize := DevSize;
    ADevMode   := GlobalLock(hPrtHandle);
    DevSize    := GlobalSize(hPrtHandle);

    try
      if DevSize > 0 then begin
        if Assigned(ASettings) then begin
          if OldDevSize = DevSize then begin
            System.Move(ASettings^, ADevMode^, DevSize);
          end else begin
            Result := False;
          end;
        end;
        try
          //DEVMODE\̂̐ADevModeASettingsɃRs[
          if Result then ModifyDevMode(ADevMode);
        except
          Result := False;
        end;
      end;
    finally
      GlobalUnlock(hPrtHandle);
    end;
    Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
  end else begin
    Result := False;
  end;


  if Result = False then begin
    if Assigned(ASettings) then begin
      FreeMem(ASettings);
      ASettings := nil;
    end;

    Printer.GetPrinter(ADevice, ADriver, APort, hPrtHandle);
    ADevMode := GlobalLock(hPrtHandle);
    DevSize  := GlobalSize(hPrtHandle);

    GetMem(ASettings, DevSize);
    try
      if (ADevMode^.dmFields and dm_PaperSize) <> 0 then begin
        //p
        if (ADevMode^.dmFields and dm_Orientation) <> 0 then begin
          if FOrientation=poPortrait  then ADevMode^.dmOrientation := DMORIENT_PORTRAIT;
          if FOrientation=poLandscape then ADevMode^.dmOrientation := DMORIENT_LANDSCAPE;
        end;
        //pTCYԍ
        if (ADevMode^.dmFields and dm_PaperSize) <> 0 then begin
          ADevMode^.dmPaperSize := FPaperNumber;
        end;
        //rԍ
        if (ADevMode^.dmFields and dm_DefaultSource) <> 0 then begin
          ADevMode^.dmDefaultSource := FBinNumber;
        end;
        //DEVMODE\̂̐ADevModeASettingsɃRs[
        ModifyDevMode(ADevMode);
      end;
    finally
      GlobalUnlock(hPrtHandle);
    end;
    Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
  end;

  //AvNFdsPrinterName͐݌ṽv^
  //rŃv^ύXꍇ́C̃v^ƂȂ
  FdsPrinterName := FPrinterName;
end;

//=============================================================================
//  v^̃vpeBݒAO\ J\bh
//
//  ݌v
//  Ŋe̐ݒsCݒ肵vpeBXg[ɕۑ
//  [OK]ŕTrueC[LZ]ŕFalseԂ
//
//  s
//  ShowDialog\bhŃvpeB̃_CAO\ۂɌďoD
//=============================================================================
function TplSetPrinter.EditPrinterInfo: Boolean;
var
  hPrt : THandle;
  IDNo : Integer;
  Mode : DWORD;
begin
  Result := False;
  if FPrintersCount = 0 then exit;

  //v^ςĂȂ`FbN
  //ςĂ猻݂̃v^{R|FPrinterNamẽv^ɕύX
  ModifyOrGetDevModeBegin;

  Mode := DM_PROMPT or DM_MODIFY or DM_COPY;
  try
    OpenPrinter(ADevice, hPrt, nil);
    try
      IDNo := DocumentProperties(Application.Handle, hPrt, ADevice, ADevMode^, ADevMode^, Mode);
    finally
      ClosePrinter(hPrt);
    end;
  finally
    GlobalUnlock(hPrtHandle);
  end;

  if IDNo=IDOK then begin
    Printer.SetPrinter(ADevice, ADriver, APort, hPrtHandle);
    GetPropertiesAndSettings;
  end;

  //[OK]ŕIDNo=IDOK
  //[LZ]ŕIDNo=IDCANCEL
  Result := IDNo=IDOK;
end;

//=============================================================================
//  R|ێĂv^̃v^݂̃v^ɂăvpeB
//  ĐݒsJ\bh
//=============================================================================
procedure TplSetPrinter.CallSetting;
begin
  //݂̃v^{R|FPrinterNamẽv^ɂ
  ChangeCurrentPrinter;

  //ۊǂĂASettingsɂvpeB(DEVMODE)̐ݒ
  SetOldPropertiesAndSettings;
end;

//=============================================================================
//  v^̃vpeBݒ_CAO\.J\bh
//  [OK]ŕTrueC[LZ]ŕFalseԂ
//=============================================================================
function TplSetPrinter.ShowDialog: Boolean;
var
  IDNo : Integer;
begin
  Result := False;
  if FPrintersCount = 0 then exit;

  if EditPrinterInfo then begin
    Result := True;
    IDNo := IDOK;
  end else begin
    IDNo := IDCANCEL;
  end;

  //_CAOOnDialogCloseCxg
  if Assigned(FOnDialogClose) then begin
    FOnDialogClose(Self,IDNo);
  end;
end;

//=============================================================================
//  [v^̐ݒ]_CAO(TPrinterSetupDialog)\ J\bh
//
//  _CAO\JnȊÕv^IƂꂪ݂̃v^ƂȂ
//  v^ɂẮC_CAO[pTCY]ύXĂύXȂ̂
//  邪C[vpeB]{^NbNŐݒ肷ƕύXłD
//  TPrinterSetupDialogPƂŎgpĂہD
//=============================================================================
function TplSetPrinter.ShowSetupDialog: Boolean;
var
  ADialog : TPrinterSetupDialog;
begin
  Result := False;
  if FPrintersCount = 0 then exit;

  ADialog         := TPrinterSetupDialog.Create(Self);
  ADialog.OnShow  := ForSetupDialogOnShow;
  ADialog.OnClose := ForSetupDialogOnClose;

  //v^ςĂȂ`FbN
  //ςĂ猻݂̃v^{R|FPrinterNamẽv^ɕύX
  ModifyOrGetDevModeBegin;
  GlobalUnlock(hPrtHandle);

  try
    if ADialog.Execute then begin
      Result := True;
      //v^擾Ă
      FPrinterNumber := Printer.PrinterIndex;
      FPrinterName   := GetPrinterNameFromString(Printer.Printers[FPrinterNumber]);
      FdsPrinterName := FPrinterName;
      //vpeB擾DEVMODEASettingsւ̃Rs[
      GetPropertiesAndSettings;
    end;
  finally
    FreeAndNil(ADialog);
  end;
end;

//=============================================================================
//  [v^̐ݒ]_CAO\ShowSetupDialog\bhp
//  _CAOOnShowCxg
//=============================================================================
procedure TplSetPrinter.ForSetupDialogOnShow(Sender: TObject);
begin
  if Assigned(FOnSetupDialogShow) then FOnSetupDialogShow(Sender);
end;
//=============================================================================
//  [v^̐ݒ]_CAO\ShowSetupDialog\bhp
//  _CAOOnCloseCxg
//=============================================================================
procedure TplSetPrinter.ForSetupDialogOnClose(Sender: TObject);
begin
  if Assigned(FOnSetupDialogClose) then FOnSetupDialogClose(Sender);
end;

//=============================================================================
//  R[hI
//=============================================================================
end.

